#!/bin/bash

 ##############################################################################
 # Filename: bash/changelog.sh
 #
 # This file is part of the JAS project.
 # Copyright 2003-2015 by Matthijs Schuurman
 #
 # The JAS project is free software under the terms of the
 # GNU Lesser General Public License version 3 or any later version.
 #
 # For information about the license please refer to:
 # LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 ##############################################################################


cd "`dirname $0`/../"
. ./bash/functions.sh

title "Changelog generator" "0.2"


CHANGELOGFILE="changelog.txt"

if [ "$1" != "" ]; then
 DIRS="$1"
else
 DIRS="hg"
fi

if [ "$DIRS" == "jas" ]; then
 DIRS="./"
else
 DIRS="`getDirectories \"$DIRS\"`"
fi

for DIR in $DIRS; do
{
 action "Generating changelog for" "$DIR"
 CHANGELOG=`generateChangelog "$DIR"`

 status $? "$CHANGELOG" #error hangling
 if [ $? == 1 ]; then echo ; continue ; fi

 #write output to changelog file
 if [ -d "$DIR/include/" -a "`echo $DIR | grep 'plugins/'`" == "" ] ; then
  echo "$CHANGELOG" > "$DIR/include/$CHANGELOGFILE"
 else
  echo "$CHANGELOG" > "$DIR/$CHANGELOGFILE"
 fi
}
done

echo
