<?

 /*****************************************************************************
 * Filename: include.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 if(!ini_get("date.timezone"))
  date_default_timezone_set("UTC");

 if(!isset($_benchmark))
  $_benchmark=false;

//set basic path
 if(!isset($_path)||!isset($_path["root"]))
  $_path["root"]="";
 if(!isset($_path["include"]))
  $_path["include"]=$_path["root"]."include/";

//init session
 require_once($_path["include"]."session.php");

//detect project
 if(!$_session->get("project"))
 {
  if(isset($_project)&&$_project&&preg_match("/^([a-z0-9]{1,25})$/i", $_project)) //$_project?
  {
   $_session->set("project", $_project);
   unset($_project);
  }
  else if(preg_match("!project/([a-z0-9]{1,25})/!i", $_SERVER["SCRIPT_FILENAME"], $tmp)) //project dir in script filename?
   $_session->set("project", $tmp[1]);
  else if(isset($_SERVER["PWD"])&&preg_match("!project/([a-z0-9]{1,25})/!i", $_SERVER["PWD"], $tmp)) //cli: maybe in current path?
   $_session->set("project", $tmp[1]);
  else
   $_session->set("project", "jas");
 }

//setup path
 require($_path["include"]."path.php");

//mod_rewrite detection
 require($_path["include"]."rewrite.php");

 require_once($_path["include"]."config.php");
 $_config->load();

//send basic headers
 require_once($_path["include"]."headers.php");
 Headers::basicS();

//php configuration, read after config
 require($_path["include"]."php.ini.php");

//browser and os detection
 require($_path["include"]."browser.php");

//mod_rewrite HTML paths
 require($_path["include"]."rewrite.php");

//setup _benchmark
 if($_config->get("benchmark")&&!$_benchmark)
 {
  require_once($_path["include"]."benchmark.php");
  $_benchmark=new Benchmark();
 }

//detect current project from JAS sites config
 if($_session->get("project")==$_session->backendKey()&&$_session->getKey()!=$_session->backendKey()&&$_config->get("sites"))
 {
  foreach($_config->get("sites") as $site)
  {
   if($site["current"])
   {
    if($_session->get("project")==$site["project"]) //current project (jas) already active
     $_config->set("sites"); //don't keep trying to detect current site
    else
    {
     $_session->set("project", $site["project"]); //overwrite project variable
     $_config->set(false); //clear config (including user/groups)

     unset($_path["project"]); //clear project path definition
     require($_path["root"]."include.php"); //init basics
    }
   }
  }

  unset($site);
 }
?>
