<?

 /*****************************************************************************
 * Filename: include/module.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."errors.php");

 class Module
 {
  function __construct(&$data)
  {
   $this->data=&$data;
  }

  function extend($module)
  {
   if($module==$this->data->module)
   {
    $this->data->e->add("Can't extend same module", "module", $module);
    return false;
   }

   if(isset($this->data->extends[$module]))
    $this->data->extends[$module]=clone $this->data->extends[$module];
   else
    $this->data->extends[$module]=Data::cache($module, $this->data->action, $this->data->extra, Array("format" => $this->data->dataformat, "request" => $this->data->requestVar, "db" => $this->data->db, "skipSetRequest" => true, "skipPostInit" => true));

   $this->data->extends[$module]->extendedBy[$this->data->module]=&$this->data;

   $this->data->extends[$module]->dataformat=&$this->data->dataformat;
   $this->data->extends[$module]->requestVar=&$this->data->requestVar;
   $this->data->extends[$module]->db=&$this->data->db;
   $this->data->extends[$module]->plugin=&$this->data->plugin;

   $this->data->extends[$module]->title=&$this->data->title;

   //merge action list
   foreach($this->data->extends[$module]->actionList as $action)
    if(!in_array($action, $this->data->actionList))
     $this->data->addActions($action);

   $this->data->extends[$module]->actionList=&$this->data->actionList;

   //merge extra list
   foreach(array_keys($this->data->extends[$module]->extraList) as $action)
    foreach($this->data->extends[$module]->extraList[$action] as $extra)
     if(!in_array($extra, $this->data->extraList[$action]))
      $this->data->addExtra($action, $extra);

   $this->data->extends[$module]->extraList=&$this->data->extraList;


   foreach(array_keys($this->data->extends[$module]->field) as $key)
   {
    if(!isset($this->data->field[$key]))
     $this->data->field[$key]=&$this->data->extends[$module]->field[$key];
    else
     $this->data->extends[$module]->field[$key]=&$this->data->field[$key];

    if(!isset($this->data->listOptions[$key]))
    {
     if(isset($this->data->extends[$module]->listOptions[$key]))
      $this->data->listOptions[$key]=&$this->data->extends[$module]->listOptions[$key];
    }
    else
     $this->data->extends[$module]->listOptions[$key]=&$this->data->listOptions[$key];
   }

   foreach(array_keys($this->data->extends[$module]->reference) as $key)
   {
    if(!isset($this->data->reference[$key]))
     $this->data->reference[$key]=&$this->data->extends[$module]->reference[$key];
    else
     $this->data->extends[$module]->reference[$key]=&$this->data->reference[$key];
   }

   return true;
  }

  function extendBy($module)
  {
   if($module==$this->data->module)
   {
    $this->data->e->add("Can't extend same module", "module", $module);
    return false;
   }

   if(isset($this->data->extendedBy[$module]))
    $this->data->extendedBy[$module]=clone $this->data->extendedBy[$module];
   else
    $this->data->extendedBy[$module]=Data::cache($module, $this->data->action, $this->data->extra, Array("format" => $this->data->dataformat, "request" => $this->data->requestVar, "db" => $this->data->db, "skipSetRequest" => true, "skipPostInit" => true));

   $this->data->extendedBy[$module]->extends[$this->data->module]=&$this->data;

   $this->data->extendedBy[$module]->action=&$this->data->action;
   $this->data->extendedBy[$module]->extra=&$this->data->extra;
   $this->data->extendedBy[$module]->dataformat=&$this->data->dataformat;
   $this->data->extendedBy[$module]->requestVar=&$this->data->requestVar;
   $this->data->extendedBy[$module]->db=&$this->data->db;
   $this->data->extendedBy[$module]->plugin=&$this->data->plugin;

   $this->data->title=&$this->data->extendedBy[$module]->title;

   //merge action list
   foreach($this->data->extendedBy[$module]->actionList as $action)
    if(!in_array($action, $this->data->actionList))
     $this->data->addActions($action);

   $this->data->extendedBy[$module]->actionList=&$this->data->actionList;

   //merge extra list
   foreach(array_keys($this->data->extendedBy[$module]->extraList) as $action)
    foreach($this->data->extendedBy[$module]->extraList[$action] as $extra)
     if(!in_array($extra, $this->data->extraList[$action]))
      $this->data->addExtra($action, $extra);

   $this->data->extendedBy[$module]->extraList=&$this->data->extraList;


   foreach(array_keys($this->data->extendedBy[$module]->field) as $key)
   {
    if(!isset($this->data->field[$key]))
     $this->data->field[$key]=&$this->data->extendedBy[$module]->field[$key];
    else
     $this->data->extendedBy[$module]->field[$key]=&$this->data->field[$key];

    if(!isset($this->data->listOptions[$key]))
    {
     if(isset($this->data->extendedBy[$module]->listOptions[$key]))
      $this->data->listOptions[$key]=&$this->data->extendedBy[$module]->listOptions[$key];
    }
    else
     $this->data->extendedBy[$module]->listOptions[$key]=&$this->data->listOptions[$key];
   }

   foreach(array_keys($this->data->extendedBy[$module]->reference) as $key)
   {
    if(!isset($this->data->reference[$key]))
     $this->data->reference[$key]=&$this->data->extendedBy[$module]->reference[$key];
    else
     $this->data->extendedBy[$module]->reference[$key]=&$this->data->reference[$key];
   }

   return true;
  }
 }

?>
