<?

 /*****************************************************************************
 * Filename: include/modules/configEmail.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");
 require_once($_path["include"]."jas.php");

 class System_Module_configEmail extends Module
 {
  function __construct(&$data)
  {
   global $_config;

   parent::__construct($data);

   if(!$_config->get("modules.".$this->data->module.".field.mimeVersion"))
   {
    $mimeVersion=Array(
     "decimals" => 1,
     "decimalseparator" => ".",
     "thousandsseparator" => "",
     "formdecimals" => 1,
     "formdecimalseparator" => $this->data->format["form"]["decimalseparator"],
     "formthousandsseparator" => $this->data->format["form"]["thousandsseparator"],
    );

    $_config->set("modules.".$this->data->module.".field.mimeVersion", $mimeVersion);
   }

   $this->data->title="Email configuration";

   $this->data->defaultFields("id;added;updated");
   $this->data->setShowFields(); //clear show fields

   $this->data->addField("userrights", "rights", "", "allusers", 0, false, 256); //view rights for all
   $this->data->addField("faketitle", "text", "show", "title;hidden", 0, false, $this->data->title, "Title");

   $this->data->addField("mimeVersion", "float", "all", false, 0, false, 1.0, "Mime version", "Set to 0 for no mime version");
   $this->data->addField("encoding", "text", "all", false, 5, 15, "ISO-8859-1", "Character encoding");
   $this->data->addField("userAgent", "text", "all", false, 0, 25, "JAS/".JAS::versionS(), "User agent", "Leave empty for no user agent header");
   $this->data->addField("defaultDomain", "domain", "all", false, 4, 50, "default.domain", "Default domain");

   $this->data->addField("wordwrap", "nr", "all", false, 0, false, 80, "Word wrap", "Set to 0 for no word wrap");

   $this->data->addField("server", "hostname", "all", false, 1, 50, "localhost", "Server");
   $this->data->addField("port", "nr", "all", false, 1, false, 25, "Port");
   $this->data->addField("username", "title", "all", "disabled", 0, 25, "", "Username", "Leave empty for no authentication");
   $this->data->addField("password", "password", "all", "disabled", 0, 25, "", "Password", "Leave empty for no authentication");

   $this->data->group("Alternative server", "server", "port", "username", "password", "verifypassword");
  }

  function editPostGet()
  {
   for($c=0;$c<$this->data->vmax;$c++)
    $this->data->setValue("password", "", $c);

   return true;
  }

  function viewPostGet()
  {
   for($c=0;$c<$this->data->vmax;$c++)
    $this->data->setValue("faketitle", $this->data->title, $c);

   return true;
  }

 }

?>
