<?

 /*****************************************************************************
 * Filename: include/modules/configModules.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");

 class System_Module_configModules extends Module
 {
  function __construct(&$data)
  {
   global $_config;
   
   parent::__construct($data);

   $this->data->l->read("module_config");
   $this->data->title="Modules configuration";

   $this->data->defaultFields("id;added;updated");
   $this->data->setShowFields(); //clear show fields

   $this->data->addField("userrights", "rights", "", "allusers", 0, false, 256); //view rights for all

   $this->data->addField("module", "module", "all", "title", 1, 25, "", "Module", "Which module this configuration applies to");

   if(function_exists("timezone_identifiers_list")) //no timezone support for PHP < 5.1.0
   {
    $this->data->addField("timezone", "list", "all", false, 0, 25, "", "Display timezone", "Leave empty for global config value");
    $this->data->listOptions("timezone", array_merge(Array(""), timezone_identifiers_list()));
    $this->data->addField("formtimezone", "list", "all", false, 0, 25, "", "Input timezone", "Leave empty for global config value");
    $this->data->listOptions("formtimezone", array_merge(Array(""), timezone_identifiers_list()));
   }

   $this->data->addField("defaultcategory", "enum", "all", false, false, false, "Default", "Default category", "Which category to use by default when adding new items");
   $this->data->enumOptions("defaultcategory", "Default", "First", "Last", "Last used");

   $this->data->addField("dateformat", "text", "all", false, 0, 10, "", "Display date format", "Leave empty for global config value");
   $this->data->addField("formdateformat", "text", "all", false, 0, 10, "", "Input date format", "Leave empty for global config value");
   $this->data->addField("timeformat", "text", "all", false, 0, 10, "", "Display time format", "Leave empty for global config value");
   $this->data->addField("formtimeformat", "text", "all", false, 0, 10, "", "Input time format", "Leave empty for global config value");
   $this->data->addField("datetimeformat", "text", "all", false, 0, 25, "", "Display date and time format", "Leave empty for global config value");
   $this->data->addField("formdatetimeformat", "text", "all", false, 0, 25, "", "Input date and time format", "Leave empty for global config value");

   $this->data->addField("decimals", "nr", "all", false, -1, 100, -1, "Display number of decimals", "Set to -1 for global config value");
   $this->data->addField("formdecimals", "nr", "all", false, -1, 100, -1, "Input number of decimals", "Set to -1 for global config value");
   $this->data->addField("decimalseparator", "text", "all", false, 0, 1, "", "Display decimal separation character", "Leave empty for global config value");
   $this->data->addField("formdecimalseparator", "text", "all", false, 0, 1, "", "Input decimal separation character", "Leave empty for global config value");
   $this->data->addField("thousandsseparator", "text", "all", false, 0, 1, "", "Display thousands separation character", "Leave empty for global config value");
   $this->data->addField("formthousandsseparator", "text", "all", false, 0, 1, "", "Input thousands separation character", "Leave empty for global config value");

   $this->data->group("Display formatting", "timezone", "dateformat", "timeformat", "datetimeformat", "decimals", "decimalseparator", "thousandsseparator");
   $this->data->group("Input formatting", "formtimezone", "formdateformat", "formtimeformat", "formdatetimeformat", "formdecimals", "formdecimalseparator", "formthousandsseparator");
  }

 }

?>
