<?

 /*****************************************************************************
 * Filename: include/modules/pluginConfigs.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");

 class System_Module_pluginConfigs extends Module
 {
  function __construct(&$data)
  {
   global $_path;

   parent::__construct($data);

   $this->data->title="Plugin configuration";

   $this->data->defaultFields();

   $this->data->addField("plugin", "plugin", "all", "title;reload", 1, 25, false, "Plugin name");
   $this->data->addField("key", "text", "all", "title", 1, 25, false, "Key", "Leave empty for random key");

   $this->data->addUnique("plugin", "plugin", "key");
  }

  function postInit()
  {
   if($this->data->action=="add"||$this->data->action=="edit")
   {
    if(!$this->setPlugin())
     return false;

    $this->data->field["plugin"]["use"]="sql;show";

    unset($this->data->field["m"]);
    $this->data->addField("m", "list", "show;form", "title;reload", 1, 25, false, "Plugin");

    $modules=Array();
    foreach(JAS::modules() as $module)
     if(preg_match(REGEXP_DATA_PLUGIN_MODULE, $module, $tmp))
      if($tmp[2]=="pluginConfigs")
       $modules[$module]=$tmp[1];

    $this->data->listOptions("m", $modules);
   }

   return true;
  }

  function addPreSubmitErrorCheck(){return $this->editPreSubmitErrorCheck();}
  function editPreSubmitErrorCheck()
  {
   if(!$this->setPlugin())
    return false;

   if(!$this->generateKeys())
    return false;

   return true;
  }

  function generateKeys()
  {
   for($c=0;$c<$this->data->vmax;$c++)
   {
    if($this->data->getValueType("key")!="none"&&!$this->data->getValue("key", $c))
     $this->data->setValue("key", substr(md5(time()), 0, 25), $c);
   }

   return true;
  }

  function setPlugin()
  {
   if($this->data->action=="add"||$this->data->action=="edit")
   {
    if($this->data->plugin)
    {
     $this->data->field["m"]["properties"].=";hidden";

     for($c=0;$c<$this->data->vmax;$c++)
      $this->data->setValue("plugin", $this->data->plugin->name, $c);
    }
   }

   return true;
  }

 }
?>
