<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/form.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/core.php");
 require_once($_path["include"]."form.php");

 class UT_Form extends UT_Classes
 {
  function Constructor()
  {
   $object=new Form();

   if(!is_object($object)||get_class($object)!="Form")
   {
    $this->e->add("Constructor doesn't return a Form object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Copy_Constructor()
  {
   $orig=new Form();
   $copy=clone $orig;

   if(!$this->_compare($orig, $copy))
   {
    $this->e->add("Form object copy doesn't match original", "error");
    return UT_FAILED;
   }

   $copy->form=-1;
   if($orig->form==$copy->form)
   {
    $this->e->add("Form object copy also modified original \"form\" variable", "error");
    return UT_FAILED;
   }

   $copy->l->sets=Array("test");
   if($orig->l->sets==$copy->l->sets)
   {
    $this->e->add("Form object copy also modified original \"Language\" object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Start()
  {
   return UT_SKIPPED;
  }

  function Input()
  {
   return UT_SKIPPED;
  }

  function Button()
  {
   return UT_SKIPPED;
  }

  function Checkbox()
  {
   return UT_SKIPPED;
  }

  function Radio()
  {
   return UT_SKIPPED;
  }

  function SelectStart()
  {
   return UT_SKIPPED;
  }

  function SelectOption()
  {
   return UT_SKIPPED;
  }

  function SelectEnd()
  {
   return UT_SKIPPED;
  }

  function Select()
  {
   return UT_SKIPPED;
  }

  function ListView()
  {
   return UT_SKIPPED;
  }

  function DataSelect()
  {
   return UT_SKIPPED;
  }

  function DataListView()
  {
   return UT_SKIPPED;
  }

  function OrderListValues()
  {
   return UT_SKIPPED;
  }

  function WYSIWYG()
  {
   return UT_SKIPPED;
  }

  function CheckWYSIWYG()
  {
   return UT_SKIPPED;
  }

  function Rights()
  {
   return UT_SKIPPED;
  }

  function End()
  {
   return UT_SKIPPED;
  }
 }

?>
