<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/format.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/core.php");
 require_once($_path["format"]."format.php");

 class UT_Format extends UT_Classes
 {
  function _init()
  {
   global $_path;

   $this->testfile=$_path["plugins"]."unit_testing/misc/format.txt";
   $this->outputfile=$_path["plugins"]."unit_testing/misc/output.txt";

   $this->testdata="Lorem Ipsum?
Ipsum?
Lorem?";

   $this->values=Array(
    "Lorem Ipsum?",
    "Ipsum?",
    "Lorem?",
   );
  }

  function Constructor()
  {
   $object=new Format();

   if(!is_object($object)||get_class($object)!="Format")
   {
    $this->e->add("Constructor doesn't return a Format object", "error");
    return UT_FAILED;
   }

   if(!is_object($object->fs)||get_class($object->fs)!="FS")
   {
    $this->e->add("Object: \"e\" isn't a FS object", "error");
    return UT_FAILED;
   }

   if(!is_object($object->e)||get_class($object->e)!="Errors")
   {
    $this->e->add("Object: \"e\" isn't an Errors object", "error");
    return UT_FAILED;
   }

   if($object->output)
   {
    $this->e->add("Output isn't empty", "error");
    return UT_FAILED;
   }

   if($object->original)
   {
    $this->e->add("Original isn't empty", "error");
    return UT_FAILED;
   }

   if(!is_array($object->data))
   {
    $this->e->add("Data isn't an array", "error");
    return UT_FAILED;
   }
   if($object->data)
   {
    $this->e->add("Data isn't empty", "error");
    return UT_FAILED;
   }

   if($object->filename)
   {
    $this->e->add("Filename isn't empty", "error");
    return UT_FAILED;
   }

   if($object->vc!==0)
   {
    $this->e->add("Value counter should be at 0", "error");
    return UT_FAILED;
   }
   if($object->vmax!==0)
   {
    $this->e->add("Value max counter should be at 0", "error");
    return UT_FAILED;
   }
   if($object->v)
   {
    $this->e->add("Value isn't empty", "error");
    return UT_FAILED;
   }

   if($object->encoding!="ISO-8859-1")
   {
    $this->e->add("Encoding should be ISO-8859-1", "error");
    return UT_FAILED;
   }

   if($object->contentType!="text/plain")
   {
    $this->e->add("Content type should be text/plain", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Copy_Constructor()
  {
   $orig=new Format();
   $copy=clone $orig;

   if(!$this->_compare($orig, $copy))
   {
    $this->e->add("Format object copy doesn't match original", "error");
    return UT_FAILED;
   }

   $copy->encoding=-1;
   if($orig->encoding==$copy->encoding)
   {
    $this->e->add("Format object copy also modified original \"encoding\" variable", "error");
    return UT_FAILED;
   }

   $copy->e->errors=-1;
   if($orig->e->errors==$copy->e->errors)
   {
    $this->e->add("Format object copy also modified original \"Error\" object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function Clear()
  {
   $f=new Format();
   $f->output="asd";
   $f->original="asd";
   $f->data=Array("asd");

   $f->filename="asd";

   $f->vc=1;
   $f->vmax=1;
   $f->v=Array("asd");

   $f->clear();

   if($f->output)
   {
    $this->e->add("Output isn't empty", "error");
    return UT_FAILED;
   }

   if($f->original)
   {
    $this->e->add("Original isn't empty", "error");
    return UT_FAILED;
   }

   if(!is_array($f->data))
   {
    $this->e->add("Data isn't an array", "error");
    return UT_FAILED;
   }
   if($f->data)
   {
    $this->e->add("Data isn't empty", "error");
    return UT_FAILED;
   }

   if($f->filename)
   {
    $this->e->add("Filename isn't empty", "error");
    return UT_FAILED;
   }

   if($f->vc!==0)
   {
    $this->e->add("Value counter should be at 0", "error");
    return UT_FAILED;
   }
   if($f->vmax!==0)
   {
    $this->e->add("Value max counter should be at 0", "error");
    return UT_FAILED;
   }
   if($f->v)
   {
    $this->e->add("Value isn't empty", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function Reset()
  {
   $this->_init();
   $f=new Format();

   $f->data=$this->values;
   $f->vmax=sizeof($f->data);

   if($f->vc!==0)
   {
    $this->e->add("Value counter should be at 0", "error");
    return UT_FAILED;
   }
   if($f->v)
   {
    $this->e->add("Value isn't empty", "error");
    return UT_FAILED;
   }

   if(!$f->next())
   {
    $this->e->add("Next shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }
   if($f->vc!==1)
   {
    $this->e->add("Value counter should be at 1", "error");
    return UT_FAILED;
   }
   if($f->v!="Lorem Ipsum?")
   {
    $this->e->add("Value doesn't match", "error");
    return UT_FAILED;
   }

   $f->reset();
   if($f->vc!==0)
   {
    $this->e->add("Value counter should be at 0", "error");
    return UT_FAILED;
   }
   if($f->v)
   {
    $this->e->add("Value isn't empty", "error");
    return UT_FAILED;
   }

   if(!$f->next())
   {
    $this->e->add("Next shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }
   if($f->vc!==1)
   {
    $this->e->add("Value counter should be at 1", "error");
    return UT_FAILED;
   }
   if($f->v!="Lorem Ipsum?")
   {
    $this->e->add("Value doesn't match", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Next()
  {
   $this->_init();

   $f=new Format();

   $f->data=$this->values;
   $f->vmax=sizeof($f->data);

   if($f->vc!==0)
   {
    $this->e->add("Value counter should be at 0", "error");
    return UT_FAILED;
   }
   if($f->v)
   {
    $this->e->add("Value isn't empty", "error");
    return UT_FAILED;
   }

   if(!$f->next())
   {
    $this->e->add("Next shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }
   if($f->vc!==1)
   {
    $this->e->add("Value counter should be at 1", "error");
    return UT_FAILED;
   }
   if($f->v!="Lorem Ipsum?")
   {
    $this->e->add("Value doesn't match", "error");
    return UT_FAILED;
   }

   if(!$f->next())
   {
    $this->e->add("Next shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }
   if($f->vc!==2)
   {
    $this->e->add("Value counter should be at 2", "error");
    return UT_FAILED;
   }
   if($f->v!="Ipsum?")
   {
    $this->e->add("Value doesn't match", "error");
    return UT_FAILED;
   }

   if(!$f->next())
   {
    $this->e->add("Next shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }
   if($f->vc!==3)
   {
    $this->e->add("Value counter should be at 3", "error");
    return UT_FAILED;
   }
   if($f->v!="Lorem?")
   {
    $this->e->add("Value doesn't match", "error");
    return UT_FAILED;
   }

   if($f->next())
   {
    $this->e->add("Next should have failed", "error");
    return UT_FAILED;
   }
   if($f->vc!==0)
   {
    $this->e->add("Value counter should be at 0", "error");
    return UT_FAILED;
   }
   if($f->v)
   {
    $this->e->add("Value isn't empty", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Previous()
  {
   $this->_init();

   $f=new Format();

   $f->data=$this->values;
   $f->vmax=sizeof($f->data);

   if($f->vc!==0)
   {
    $this->e->add("Value counter should be at 0", "error");
    return UT_FAILED;
   }
   if($f->v)
   {
    $this->e->add("Value isn't empty", "error");
    return UT_FAILED;
   }

   if(!$f->previous())
   {
    $this->e->add("Previous shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }
   if($f->vc!==1)
   {
    $this->e->add("Value counter should be at 1", "error");
    return UT_FAILED;
   }
   if($f->v!="Lorem?")
   {
    $this->e->add("Value doesn't match", "error");
    return UT_FAILED;
   }

   if(!$f->previous())
   {
    $this->e->add("Previous shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }
   if($f->vc!==2)
   {
    $this->e->add("Value counter should be at 2", "error");
    return UT_FAILED;
   }
   if($f->v!="Ipsum?")
   {
    $this->e->add("Value doesn't match", "error");
    return UT_FAILED;
   }

   if(!$f->previous())
   {
    $this->e->add("Previous shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }
   if($f->vc!==3)
   {
    $this->e->add("Value counter should be at 3", "error");
    return UT_FAILED;
   }
   if($f->v!="Lorem Ipsum?")
   {
    $this->e->add("Value doesn't match", "error");
    return UT_FAILED;
   }

   if($f->previous())
   {
    $this->e->add("Previous should have failed", "error");
    return UT_FAILED;
   }
   if($f->vc!==0)
   {
    $this->e->add("Value counter should be at 0", "error");
    return UT_FAILED;
   }
   if($f->v)
   {
    $this->e->add("Value isn't empty", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function First()
  {
   $this->_init();

   $f=new Format();

   $f->data=$this->values;
   $f->vmax=sizeof($f->data);

   if($f->vc!==0)
   {
    $this->e->add("Value counter should be at 0", "error");
    return UT_FAILED;
   }
   if($f->v)
   {
    $this->e->add("Value isn't empty", "error");
    return UT_FAILED;
   }

   if(!$f->first())
   {
    $this->e->add("First shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }
   if($f->vc!==0)
   {
    $this->e->add("Value counter should be at 0", "error");
    return UT_FAILED;
   }
   if($f->v!="Lorem Ipsum?")
   {
    $this->e->add("Value doesn't match", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Last()
  {
   $this->_init();

   $f=new Format();

   $f->data=$this->values;
   $f->vmax=sizeof($f->data);

   if($f->vc!==0)
   {
    $this->e->add("Value counter should be at 0", "error");
    return UT_FAILED;
   }
   if($f->v)
   {
    $this->e->add("Value isn't empty", "error");
    return UT_FAILED;
   }

   if(!$f->last())
   {
    $this->e->add("Last shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }
   if($f->vc!==0)
   {
    $this->e->add("Value counter should be at 0", "error");
    return UT_FAILED;
   }
   if($f->v!="Lorem?")
   {
    $this->e->add("Value doesn't match", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Search()
  {
   $this->_init();
   $f=new Format();

   $f->data=$this->values;
   $f->vmax=sizeof($f->data);

   if($f->vc!==0)
   {
    $this->e->add("Value counter should be at 0", "error");
    return UT_FAILED;
   }
   if($f->v)
   {
    $this->e->add("Value isn't empty", "error");
    return UT_FAILED;
   }

   if(!$f->search("Lorem"))
   {
    $this->e->add("Search shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }
   if($f->vc!==1)
   {
    $this->e->add("Value counter should be at 1", "error");
    return UT_FAILED;
   }
   if($f->v!="Lorem Ipsum?")
   {
    $this->e->add("Value doesn't match", "error");
    return UT_FAILED;
   }

   if(!$f->search("lorem"))
   {
    $this->e->add("Search shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }
   if($f->vc!==3)
   {
    $this->e->add("Value counter should be at 3", "error");
    return UT_FAILED;
   }
   if($f->v!="Lorem?")
   {
    $this->e->add("Value doesn't match", "error");
    return UT_FAILED;
   }

   if($f->search("Lorem"))
   {
    $this->e->add("Search should have failed", "error");
    return UT_FAILED;
   }
   if($f->vc!==0)
   {
    $this->e->add("Value counter should be at 0", "error");
    return UT_FAILED;
   }
   if($f->v)
   {
    $this->e->add("Value isn't empty", "error");
    return UT_FAILED;
   }

   if($f->search("ASDASD"))
   {
    $this->e->add("Search should have failed", "error");
    return UT_FAILED;
   }
   if($f->vc!==0)
   {
    $this->e->add("Value counter should be at 0", "error");
    return UT_FAILED;
   }
   if($f->v)
   {
    $this->e->add("Value isn't empty", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Value()
  {
   $this->_init();

   $f=new Format();

   $f->data=$this->values;
   $f->vmax=sizeof($f->data);

   if($f->vc!==0)
   {
    $this->e->add("Value counter should be at 0", "error");
    return UT_FAILED;
   }
   if($f->v)
   {
    $this->e->add("Value isn't empty", "error");
    return UT_FAILED;
   }

   if(!$f->value(0))
   {
    $this->e->add("Value shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }
   if($f->v!="Lorem Ipsum?")
   {
    $this->e->add("Value doesn't match", "error");
    return UT_FAILED;
   }

   if(!$f->value(1))
   {
    $this->e->add("Value shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }
   if($f->v!="Ipsum?")
   {
    $this->e->add("Value doesn't match", "error");
    return UT_FAILED;
   }

   if(!$f->value(2))
   {
    $this->e->add("Value shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }
   if($f->v!="Lorem?")
   {
    $this->e->add("Value doesn't match", "error");
    return UT_FAILED;
   }

   if($f->value(3))
   {
    $this->e->add("Value should have failed", "error");
    return UT_FAILED;
   }
   if($f->v)
   {
    $this->e->add("Value isn't empty", "error");
    return UT_FAILED;
   }

   if($f->value(-1))
   {
    $this->e->add("Value should have failed", "error");
    return UT_FAILED;
   }
   if($f->v)
   {
    $this->e->add("Value isn't empty", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function Parse()
  {
   $this->_init();
   $f=new Format();

   if(!$f->parse($this->testdata))
   {
    $this->e->add("Parse shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }

   if($f->output!=$this->testdata)
   {
    $this->e->add("Output doesn't match", "error");
    return UT_FAILED;
   }

   if($f->original!=$this->testdata)
   {
    $this->e->add("Original doesn't match", "error");
    return UT_FAILED;
   }

   if($f->vmax!=3)
   {
    $this->e->add("Vmax should be 3", "error");
    return UT_FAILED;
   }

   if(!$this->_compare($this->values, $f->data))
    return UT_FAILED;


   return UT_OK;
  }

  function ReParse()
  {
   $this->_init();
   $f=new Format();

   if(!$f->parse($this->testdata))
   {
    $this->e->add("Parse shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }

   if($f->output!=$this->testdata)
   {
    $this->e->add("Output doesn't match", "error");
    return UT_FAILED;
   }

   if($f->original!=$this->testdata)
   {
    $this->e->add("Original doesn't match", "error");
    return UT_FAILED;
   }

   if($f->vmax!=3)
   {
    $this->e->add("Vmax should be 3", "error");
    return UT_FAILED;
   }

   if(!$this->_compare($this->values, $f->data))
    return UT_FAILED;


   //reparse original
   $this->data=Array();
   $this->output="";

   if(!$f->reparse())
   {
    $this->e->add("ReParse shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }

   if($f->output!=$this->testdata)
   {
    $this->e->add("Output doesn't match", "error");
    return UT_FAILED;
   }

   if($f->original!=$this->testdata)
   {
    $this->e->add("Original doesn't match", "error");
    return UT_FAILED;
   }

   if($f->vmax!=3)
   {
    $this->e->add("Vmax should be 3", "error");
    return UT_FAILED;
   }

   if(!$this->_compare($this->values, $f->data))
    return UT_FAILED;


   //reparse output
   $this->data=Array();
   $this->original="";

   if(!$f->reparse(true))
   {
    $this->e->add("ReParse shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }

   if($f->output!=$this->testdata)
   {
    $this->e->add("Output doesn't match", "error");
    return UT_FAILED;
   }

   if($f->original!=$this->testdata)
   {
    $this->e->add("Original doesn't match", "error");
    return UT_FAILED;
   }

   if($f->vmax!=3)
   {
    $this->e->add("Vmax should be 3", "error");
    return UT_FAILED;
   }

   if(!$this->_compare($this->values, $f->data))
    return UT_FAILED;


   //reparse fail
   $f->clear();

   if($f->reparse())
   {
    $this->e->add("ReParse should have failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Read()
  {
   $this->_init();
   $f=new Format();

   if(!$f->read($this->testfile, false))
   {
    $this->e->add("Read shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }

   if($f->filename!=$this->testfile)
   {
    $this->e->add("Filename doesn't match", "error");
    return UT_FAILED;
   }

   if($f->output!=$this->testdata)
   {
    $this->e->add("Output doesn't match", "error");
    return UT_FAILED;
   }

   if($f->original!=$this->testdata)
   {
    $this->e->add("Original doesn't match", "error");
    return UT_FAILED;
   }

   //read parse
   if(!$f->read($this->testfile))
   {
    $this->e->add("Read shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }

   if($f->filename!=$this->testfile)
   {
    $this->e->add("Filename doesn't match", "error");
    return UT_FAILED;
   }

   if($f->output!=$this->testdata)
   {
    $this->e->add("Output doesn't match", "error");
    return UT_FAILED;
   }

   if($f->original!=$this->testdata)
   {
    $this->e->add("Original doesn't match", "error");
    return UT_FAILED;
   }

   if($f->vmax!=3)
   {
    $this->e->add("Vmax should be 3", "error");
    return UT_FAILED;
   }

   if(!$this->_compare($this->values, $f->data))
    return UT_FAILED;


   //fail read
   if($f->read("nonexistingfile"))
   {
    $this->e->add("Read should have failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function Output()
  {
   if(headers_sent())
   {
    $this->e->add("Please use a project that uses \"output buffering\"", "warning", "The W3C plugin will suffice");
    return UT_SKIPPED;
   }

   $this->_storeHeaders();

   $this->_init();
   $f=new Format();
   $f->filename("format.txt");

   if(!$f->parse($this->testdata))
   {
    $this->e->add("Parse shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }

   if($f->output(false)!=$this->testdata)
   {
    $this->e->add("Output doesn't match", "error");
    return UT_FAILED;
   }

   if($f->output(true)!=$this->testdata)
   {
    $this->e->add("Output doesn't match", "error");
    $this->_restoreHeaders();
    return UT_FAILED;
   }

   if(!strstr(Headers::getS("Content-Type"), $f->contentType))
   {
    $this->e->add("Format output should have set content type header");
    $this->_restoreHeaders();
    return UT_FAILED;
   }

   if(!in_array("Content-Length: 26", headers_list()))
   {
    $this->e->add("Format output should have set content length header");
    $this->_restoreHeaders();
    return UT_FAILED;
   }

   if(!in_array("Content-Disposition: attachment; filename=\"format.txt\"", headers_list()))
   {
    $this->e->add("Format output should have set filename header");
    $this->_restoreHeaders();
    return UT_FAILED;
   }

   $this->_restoreHeaders();
   return UT_OK;
  }


  function Write()
  {
   $this->_init();
   $f=new Format();
   $f->filename("format.txt");

   if(!$f->parse($this->testdata))
   {
    $this->e->add("Parse shouldn't have failed", "error");
    $this->e->add($f->e);
    return UT_FAILED;
   }

   if(!$f->write($this->outputfile))
   {
    $this->e->add($csv->e);
    return UT_FAILED;
   }

   if(file_get_contents($this->outputfile)!=$f->output(false))
   {
    $this->e->add("Output file doesn't match expected output", "error");
    @unlink($this->outputfile);
    return UT_FAILED;
   }

   @unlink($this->outputfile);
   return UT_OK;
  }


 }

?>
