<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/format_rss.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/format.php");
 require_once($_path["include"]."mutilate.php");
 require_once($_path["format"]."rss.php");

 class UT_Format_RSS extends UT_Format
 {
  var $formats=Array("atom-1.0", "rss-2.0");

  var $info=Array("title" => "JAS RSS feed", "description" => "JAS example RSS feed", "link" => "https://jas.junerules.com/", "url" => "https://jas.junerules.com/api/rss/", "updated" => "2015-09-23 20:39:51", "generated" => "2015-09-22 03:12:38");

  var $entries=Array(
   Array("title" => "Title 1", "description" => "Description <b>1</b>", "link" => "http://example.com/1/", "updated" => "2015-09-21 23:39:51", "id" => false),
   Array("title" => "Title 2", "description" => "Description <b>2</b>", "link" => "http://example.com/2/", "updated" => "2015-09-21 21:39:51", "id" => "UID 2"),
   Array("title" => "Title 3", "description" => "Description <b>3</b>", "link" => "http://example.com/3/", "updated" => "2015-09-23 20:39:51", "id" => false),
   Array("title" => "Title 4", "description" => "Description <b>4</b>", "link" => "http://example.com/4/", "updated" => "2015-09-20 20:39:51", "id" => "UID 4"),
  );

  var $atom10='<?xml version="1.0" encoding="utf-8"?>
<feed xmlns="http://www.w3.org/2005/Atom">
 <title>JAS RSS feed</title>
 <subtitle>JAS example RSS feed</subtitle>
 <link href="https://jas.junerules.com/" />
 <link href="https://jas.junerules.com/api/rss/" rel="self" />
 <id>http://www.example.com/main.html</id>
 <updated>2015-09-23T20:39:51+02:00</updated>

 <entry>
  <title>Title 3</title>
  <summary>Description 3</summary>
  <content type="html">Description &lt;b&gt;3&lt;/b&gt;</content>
  <link href="http://example.com/3/" />
  <updated>2015-09-23T20:39:51+02:00</updated>
  <id>0f695ff7798de64943cb165f253bae0f</id>
 </entry><entry>
  <title>Title 1</title>
  <summary>Description 1</summary>
  <content type="html">Description &lt;b&gt;1&lt;/b&gt;</content>
  <link href="http://example.com/1/" />
  <updated>2015-09-21T23:39:51+02:00</updated>
  <id>5c228e0034fbb9d7ad72386673d4e5ec</id>
 </entry><entry>
  <title>Title 2</title>
  <summary>Description 2</summary>
  <content type="html">Description &lt;b&gt;2&lt;/b&gt;</content>
  <link href="http://example.com/2/" />
  <updated>2015-09-21T21:39:51+02:00</updated>
  <id>UID 2</id>
 </entry><entry>
  <title>Title 4</title>
  <summary>Description 4</summary>
  <content type="html">Description &lt;b&gt;4&lt;/b&gt;</content>
  <link href="http://example.com/4/" />
  <updated>2015-09-20T20:39:51+02:00</updated>
  <id>UID 4</id>
 </entry>

</feed>
';

  var $rss20='<?xml version="1.0" encoding="UTF-8" ?>
<rss version="2.0">
 <channel>
  <title>JAS RSS feed</title>
  <description>JAS example RSS feed</description>
  <link>https://jas.junerules.com/</link>
  <lastBuildDate>Tue, 22 Sep 2015 03:12:38 +0200</lastBuildDate>
  <pubDate>Wed, 23 Sep 2015 20:39:51 +0200</pubDate>

  <item>
   <title>Title 3</title>
   <description>Description &lt;b&gt;3&lt;/b&gt;</description>
   <link>http://example.com/3/</link>
   <guid>0f695ff7798de64943cb165f253bae0f</guid>
   <pubDate>Wed, 23 Sep 2015 20:39:51 +0200</pubDate>
  </item><item>
   <title>Title 1</title>
   <description>Description &lt;b&gt;1&lt;/b&gt;</description>
   <link>http://example.com/1/</link>
   <guid>5c228e0034fbb9d7ad72386673d4e5ec</guid>
   <pubDate>Mon, 21 Sep 2015 23:39:51 +0200</pubDate>
  </item><item>
   <title>Title 2</title>
   <description>Description &lt;b&gt;2&lt;/b&gt;</description>
   <link>http://example.com/2/</link>
   <guid>UID 2</guid>
   <pubDate>Mon, 21 Sep 2015 21:39:51 +0200</pubDate>
  </item><item>
   <title>Title 4</title>
   <description>Description &lt;b&gt;4&lt;/b&gt;</description>
   <link>http://example.com/4/</link>
   <guid>UID 4</guid>
   <pubDate>Sun, 20 Sep 2015 20:39:51 +0200</pubDate>
  </item>

 </channel>
</rss>
';

  function Constructor()
  {
   $object=new Format_RSS();

   if(!is_object($object)||get_class($object)!="Format_RSS")
   {
    $this->e->add("Constructor doesn't return a Format_RSS object", "error");
    return UT_FAILED;
   }

   if(!is_object($object->e)||get_class($object->e)!="Errors")
   {
    $this->e->add("Object: \"e\" isn't an Errors object", "error");
    return UT_FAILED;
   }

   if($object->format!="atom-1.0")
   {
    $this->e->add("Object format not set to: atom-1.0", "error");
    return UT_FAILED;
   }

   if($object->info["title"]!="JAS RSS feed")
   {
    $this->e->add("Object info title not set to: JAS RSS feed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Copy_Constructor()
  {
   $orig=new Format_RSS();
   $copy=clone $orig;

   if(!$this->_compare($orig, $copy))
   {
    $this->e->add("Format_RSS object copy doesn't match original", "error");
    return UT_FAILED;
   }

   $copy->format=-1;
   if($orig->format==$copy->format)
   {
    $this->e->add("Format_RSS object copy also modified original \"format\" variable", "error");
    return UT_FAILED;
   }

   $copy->e->errors=-1;
   if($orig->e->errors==$copy->e->errors)
   {
    $this->e->add("Format_RSS object copy also modified original \"Error\" object", "error");
    return UT_FAILED;
   }

   return UT_Format::Copy_Constructor(); //run parent Copy_Constructor tests
  }


  function SetFormat()
  {
   $rss=new Format_RSS();

   foreach($this->formats as $format)
   {
    if(!$rss->setFormat($format))
    {
     $this->e->add("RSS setFormat failed for: ".$format, "error");
     $this->e->add($rss->e);
     return UT_FAILED;
    }

    if($rss->format!=$format)
    {
     $this->e->add("RSS format doesn't match input: ".$format, "error");
     return UT_FAILED;
    }
   }

   $format="fail";
   if($rss->setFormat($format))
   {
    $this->e->add("RSS setFormat should fail for: ".$format, "error");
    return UT_FAILED;
   }

   if($rss->format==$format)
   {
    $this->e->add("RSS format shouldn't match input: ".$format, "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function GetFormat()
  {
   $rss=new Format_RSS();

   foreach($this->formats as $format)
   {
    if(!$rss->setFormat($format))
    {
     $this->e->add("RSS setFormat failed for: ".$format, "error");
     $this->e->add($rss->e);
     return UT_FAILED;
    }

    if($rss->getFormat()!=$format)
    {
     $this->e->add("RSS getFormat doesn't match input: ".$format, "error");
     return UT_FAILED;
    }
   }

   $format="fail";
   if($rss->setFormat($format))
   {
    $this->e->add("RSS setFormat should fail for: ".$format, "error");
    return UT_FAILED;
   }

   if($rss->getFormat()==$format)
   {
    $this->e->add("RSS getFormat shouldn't match input: ".$format, "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function SetInfo()
  {
   $rss=new Format_RSS();

   if(!$rss->setInfo("Title", "Description", "https://jas.junerules.com/"))
   {
    $this->e->add("RSS setInfo failed", "error");
    $this->e->add($rss->e);
    return UT_FAILED;
   }

   if(!$this->_compare(Array("title" => "Title", "description" => "Description", "link" => "https://jas.junerules.com/", "url" => (isset($_SERVER["HTTPS"])&&$_SERVER["HTTPS"]?"https":"http")."://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"], "updated" => false, "generated" => false), $rss->info))
    return UT_FAILED;

   if(!$rss->setInfo("Title", "Description", "https://jas.junerules.com/", "https://jas.junerules.com/api/rss/", "2015-09-22 13:41:25", "2015-09-22 13:41:16"))
   {
    $this->e->add("RSS setInfo failed", "error");
    $this->e->add($rss->e);
    return UT_FAILED;
   }

   if(!$this->_compare(Array("title" => "Title", "description" => "Description", "link" => "https://jas.junerules.com/", "url" => "https://jas.junerules.com/api/rss/", "updated" => "2015-09-22 13:41:25", "generated" => "2015-09-22 13:41:16"), $rss->info))
    return UT_FAILED;

//failures
   if($rss->setInfo("Title", "Description", "not a URL"))
   {
    $this->e->add("RSS setInfo should have failed failed", "error");
    return UT_FAILED;
   }

   if($rss->setInfo("Title", "Description", "http://example.com/rss/", "not a URL"))
   {
    $this->e->add("RSS setInfo should have failed", "error");
    return UT_FAILED;
   }

   if($rss->setInfo("Title", "Description", "http://example.com/rss/", false, "not a date"))
   {
    $this->e->add("RSS setInfo should have failed", "error");
    return UT_FAILED;
   }

   if($rss->setInfo("Title", "Description", "http://example.com/rss/", false, false, "not a date"))
   {
    $this->e->add("RSS setInfo should have failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function GetInfo()
  {
   $rss=new Format_RSS();

   if(!$rss->setInfo("Title", "Description", "Link", "URL"))
   {
    $this->e->add("RSS setInfo failed", "error");
    $this->e->add($rss->e);
    return UT_FAILED;
   }

   if($rss->getInfo()!=Array("title" => "Title", "description" => "Description", "link" => "Link", "url" => "URL", "updated" => false, "generated" => false))
   {
    $this->e->add("RSS getInfo doesn't match input", "error");
    return UT_FAILED;
   }

   foreach(Array("title" => "Title", "description" => "Description", "link" => "Link", "url" => "URL", "updated" => false, "generated" => false) as $k => $v)
   {
    if($rss->getInfo($k)!=$v)
    {
     $this->e->add("RSS getInfo doesn't match input for key: ".$key, "error");
     return UT_FAILED;
    }
   }

   return UT_OK;
  }


  function Add()
  {
   $rss=new Format_RSS();

   if(!$rss->add($this->entries[0]["title"], $this->entries[0]["description"], $this->entries[0]["link"], $this->entries[0]["updated"], $this->entries[0]["id"]))
   {
    $this->e->add("RSS add failed", "error");
    $this->e->add($rss->e);
    return UT_FAILED;
   }

   $expected=Array($this->entries[0]);
   foreach($expected as $k => $v)
    if(!$v["id"])
     $expected[$k]["id"]=md5($v["title"].$v["updated"]);

   if(!$this->_compare($expected, $rss->data))
    return UT_FAILED;

   if(!$rss->add($this->entries[1]["title"], $this->entries[1]["description"], $this->entries[1]["link"], $this->entries[1]["updated"], $this->entries[1]["id"]))
   {
    $this->e->add("RSS add failed", "error");
    $this->e->add($rss->e);
    return UT_FAILED;
   }

   $expected=Array($this->entries[0], $this->entries[1]);
   foreach($expected as $k => $v)
    if(!$v["id"])
     $expected[$k]["id"]=md5($v["title"].$v["updated"]);

   if(!$this->_compare($expected, $rss->data))
    return UT_FAILED;

   if(!$rss->add($this->entries[2]["title"], $this->entries[2]["description"], $this->entries[2]["link"], $this->entries[2]["updated"], $this->entries[2]["id"]))
   {
    $this->e->add("RSS add failed", "error");
    $this->e->add($rss->e);
    return UT_FAILED;
   }

   $expected=Array($this->entries[2], $this->entries[0], $this->entries[1]);
   foreach($expected as $k => $v)
    if(!$v["id"])
     $expected[$k]["id"]=md5($v["title"].$v["updated"]);

   if(!$this->_compare($expected, $rss->data))
    return UT_FAILED;

   if(!$rss->add($this->entries[3]["title"], $this->entries[3]["description"], $this->entries[3]["link"], $this->entries[3]["updated"], $this->entries[3]["id"]))
   {
    $this->e->add("RSS add failed", "error");
    $this->e->add($rss->e);
    return UT_FAILED;
   }

   $expected=Array($this->entries[2], $this->entries[0], $this->entries[1], $this->entries[3]);
   foreach($expected as $k => $v)
    if(!$v["id"])
     $expected[$k]["id"]=md5($v["title"].$v["updated"]);

   if(!$this->_compare($expected, $rss->data))
    return UT_FAILED;


//failures
   if($rss->add("Title", "Description", "not a URL", "2015-09-21 20:39:51"))
   {
    $this->e->add("RSS add should have failed failed", "error");
    return UT_FAILED;
   }

   if($rss->add("Title", "Description", "http://example.com/rss/", "not a date"))
   {
    $this->e->add("RSS add should have failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function Parse_Atom_1_0()
  {
   $rss=new Format_RSS();

   if(!$rss->setInfo("", "", "link")) //clear info
   {
    $this->e->add("RSS setInfo failed", "error");
    $this->e->add($rss->e);
    return UT_FAILED;
   }

   $timezone=date_default_timezone_get();
   date_default_timezone_set("Europe/Amsterdam");
   if(!$rss->parse($this->atom10))
   {
    date_default_timezone_set($timezone);
    $this->e->add("RSS parse failed", "error");
    $this->e->add($rss->e);
    return UT_FAILED;
   }
   date_default_timezone_set($timezone);


   $expected=$this->info;
   $expected["generated"]=false;
   if(!$this->_compare($expected, $rss->info))
    return false;

   $expected=Array(
    $this->entries[2],
    $this->entries[0],
    $this->entries[1],
    $this->entries[3],
   );

   foreach($expected as $k => $v)
    if(!$v["id"])
     $expected[$k]["id"]=md5($v["title"].$v["updated"]);

   if(!$this->_compare($expected, $rss->data))
    return false;

   return UT_OK;
  }

  function Parse_RSS_2_0()
  {
   $rss=new Format_RSS();

   if(!$rss->setInfo("", "", "link")) //clear info
   {
    $this->e->add("RSS setInfo failed", "error");
    $this->e->add($rss->e);
    return UT_FAILED;
   }

   $timezone=date_default_timezone_get();
   date_default_timezone_set("Europe/Amsterdam");
   if(!$rss->parse($this->rss20))
   {
    date_default_timezone_set($timezone);
    $this->e->add("RSS parse failed", "error");
    $this->e->add($rss->e);
    return UT_FAILED;
   }
   date_default_timezone_set($timezone);


   $expected=$this->info;
   $expected["url"]=(isset($_SERVER["HTTPS"])&&$_SERVER["HTTPS"]?"https":"http")."://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"];
   if(!$this->_compare($expected, $rss->info))
    return false;

   $expected=Array(
    $this->entries[2],
    $this->entries[0],
    $this->entries[1],
    $this->entries[3],
   );

   foreach($expected as $k => $v)
    if(!$v["id"])
     $expected[$k]["id"]=md5($v["title"].$v["updated"]);

   if(!$this->_compare($expected, $rss->data))
    return false;

   return UT_OK;
  }


  function Output_Atom_1_0()
  {
   $rss=new Format_RSS("atom-1.0");

   foreach($this->entries as $e)
    $rss->add($e["title"], $e["description"], $e["link"], $e["updated"], $e["id"]);

   $timezone=date_default_timezone_get();
   date_default_timezone_set("Europe/Amsterdam");
   if(!($output=$rss->output()))
   {
    date_default_timezone_set($timezone);
    $this->e->add("RSS output failed", "error");
    $this->e->add($rss->e);
    return UT_FAILED;
   }
   date_default_timezone_set($timezone);

   if(!$this->_compare($this->atom10, $output))
    return false;

   return UT_OK;
  }

  function Output_RSS_2_0()
  {
   $rss=new Format_RSS("rss-2.0");

   foreach($this->entries as $e)
    $rss->add($e["title"], $e["description"], $e["link"], $e["updated"], $e["id"]);

   $timezone=date_default_timezone_get();
   date_default_timezone_set("Europe/Amsterdam");
   if(!($output=$rss->output()))
   {
    date_default_timezone_set($timezone);
    $this->e->add("RSS output failed", "error");
    $this->e->add($rss->e);
    return UT_FAILED;
   }
   date_default_timezone_set($timezone);

   preg_match("!<lastBuildDate>(.+)</lastBuildDate>!", $output, $date);
   $expected=preg_replace("!(<lastBuildDate>).+(</lastBuildDate>)!", "\\1".$date[1]."\\2", $this->rss20);

   if(!$this->_compare($expected, $output))
    return false;

   return UT_OK;
  }

 }

?>
