<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/image.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/core.php");
 require_once($_path["include"]."image.php");

 class UT_Image extends UT_Classes
 {
  function Constructor()
  {
   $object=new Image();

   if(!is_object($object)||get_class($object)!="Image")
   {
    $this->e->add("Constructor doesn't return a Image object", "error");
    return UT_FAILED;
   }

   if(!is_object($object->e)||get_class($object->e)!="Errors")
   {
    $this->e->add("Object: \"e\" isn't an Errors object", "error");
    return UT_FAILED;
   }

   if($object->data!==false)
   {
    $this->e->add("Data value isn't false", "error");
    return UT_FAILED;
   }

   if($object->type!==false)
   {
    $this->e->add("Type value isn't false", "error");
    return UT_FAILED;
   }

   if($object->file!==false)
   {
    $this->e->add("File value isn't false", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Copy_Constructor()
  {
   $orig=new Image();
   $copy=clone $orig;

   if(!$this->_compare($orig, $copy))
   {
    $this->e->add("Image object copy doesn't match original", "error");
    return UT_FAILED;
   }

   $copy->data=true;
   if($orig->data==$copy->data)
   {
    $this->e->add("Image object copy also modified original \"data\" variable", "error");
    return UT_FAILED;
   }

   $copy->e->errors=-1;
   if($orig->e->errors==$copy->e->errors)
   {
    $this->e->add("Image object copy also modified original \"Error\" object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Output()
  {
   global $_path;

   $img=new Image();

   $this->_storeHeaders();
   if(!$img->load($_path["images"]."imagenotfound.png")) //with headers
   {
    $this->e->add("Image output load failed", "error");
    $this->e->add($img->e);
    return UT_FAILED;
   }

   if(!($output=$img->output(false, true))) //with headers
   {
    $this->e->add("Image output failed", "error");
    $this->e->add($img->e);
    return UT_FAILED;
   }

   if(!preg_grep("!Content-Disposition: attachment; filename=\"imagenotfound\.png\"!i", headers_list()))
   {
    $this->e->add("Image output Content-Disposition header not found or incorrect", "error");
    $this->_restoreHeaders();
    return UT_FAILED;
   }

   if(!preg_grep("!Content-Type: image/\w+!i", headers_list()))
   {
    $this->e->add("Image output Content-Type header not found or incorrect", "error");
    $this->_restoreHeaders();
    return UT_FAILED;
   }

   if(!preg_grep("!Content-Length: \d+!i", headers_list()))
   {
    $this->e->add("Image output Content-Length header not found or incorrect", "error");
    $this->_restoreHeaders();
    return UT_FAILED;
   }

   $this->_restoreHeaders();

   return UT_OK;
  }

 }

?>
