<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/mutilate.sro.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/mutilate.php");
 require_once($_path["include"]."mutilate.php");

 class UT_Mutilate_Scope_Resolution_Operator extends UT_Mutilate
 {
  function CallStatic()
  {
   if(!Mutilate::humanReadableNumberS(1))
   {
    $this->e->add("HumanReadableNumber shouldn't fail", "error");
    return UT_FAILED;
   }

   /*
   if(($nonexistingexecutable=Mutilate::nonexistingexecutableSSS()))
   {
    $this->e->add("nonexistingexecutableS should fail", "error");
    return UT_FAILED;
   }
   */

   return UT_OK;
  }


  function HumanReadableNumber()
  {
   if(Mutilate::humanReadableNumberS(123)!="123")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"123\" failed", "error");
    return UT_FAILED;
   }


   if(Mutilate::humanReadableNumberS(1234)!="1K")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumberS(1234, 0)!="1K")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumberS(1234, 1)!="1.2K")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234, 1\" failed", "error");
    return UT_FAILED;
   }



   if(Mutilate::humanReadableNumberS(1234567)!="1M")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumberS(1234567, 0)!="1M")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumberS(1234567, 1)!="1.2M")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567, 1\" failed", "error");
    return UT_FAILED;
   }



   if(Mutilate::humanReadableNumberS(1234567890)!="1G")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumberS(1234567890, 0)!="1G")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumberS(1234567890, 1)!="1.2G")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890, 1\" failed", "error");
    return UT_FAILED;
   }



   if(Mutilate::humanReadableNumberS(1234567890123)!="1T")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumberS(1234567890123, 0)!="1T")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumberS(1234567890123, 1)!="1.2T")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123, 1\" failed", "error");
    return UT_FAILED;
   }



   if(Mutilate::humanReadableNumberS(1234567890123456)!="1P")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123456\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumberS(1234567890123456, 0)!="1P")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123456, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableNumberS(1234567890123456, 1)!="1.2P")
   {
    $this->e->add("Mutilation humanReadableNumber with argument \"1234567890123456, 1\" failed", "error");
    return UT_FAILED;
   }


   return UT_OK;
  }

  function HumanReadableNumberArray()
  {
   if(!($values=Mutilate::humanReadableNumberS(Array(1234))))
   {
    $this->e->add("Mutilation humanReadableNumber with argument Array(1234) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="1K")
   {
    $this->e->add("Mutilation humanReadableNumber with argument Array(1234) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function HumanReadableFileSize()
  {
   if(Mutilate::humanReadableFileSizeS(123)!="123B")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"123\" failed", "error");
    return UT_FAILED;
   }


   if(Mutilate::humanReadableFileSizeS(1234)!="1KB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSizeS(1234, 0)!="1KB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSizeS(1234, 1)!="1.2KB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234, 1\" failed", "error");
    return UT_FAILED;
   }



   if(Mutilate::humanReadableFileSizeS(1234567)!="1MB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSizeS(1234567, 0)!="1MB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSizeS(1234567, 1)!="1.2MB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567, 1\" failed", "error");
    return UT_FAILED;
   }



   if(Mutilate::humanReadableFileSizeS(1234567890)!="1GB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSizeS(1234567890, 0)!="1GB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSizeS(1234567890, 1)!="1.2GB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890, 1\" failed", "error");
    return UT_FAILED;
   }



   if(Mutilate::humanReadableFileSizeS(1234567890123)!="1TB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSizeS(1234567890123, 0)!="1TB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSizeS(1234567890123, 1)!="1.2TB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123, 1\" failed", "error");
    return UT_FAILED;
   }



   if(Mutilate::humanReadableFileSizeS(1234567890123456)!="1PB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123456\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSizeS(1234567890123456, 0)!="1PB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123456, 0\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::humanReadableFileSizeS(1234567890123456, 1)!="1.2PB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument \"1234567890123456, 1\" failed", "error");
    return UT_FAILED;
   }


   return UT_OK;
  }

  function HumanReadableFileSizeArray()
  {
   if(!($values=Mutilate::humanReadableFileSizeS(Array(1234))))
   {
    $this->e->add("Mutilation humanReadableFileSize with argument Array(1234) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="1KB")
   {
    $this->e->add("Mutilation humanReadableFileSize with argument Array(1234) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function LeadingZeros()
  {
   if(Mutilate::leadingZerosS(12, 5)!="00012")
   {
    $this->e->add("Mutilation leadingZeros with argument \"12\" failed", "error");
    return UT_FAILED;
   }


   if(Mutilate::leadingZerosS(12, 2)!="12")
   {
    $this->e->add("Mutilation leadingZeros with argument \"12\" failed", "error");
    return UT_FAILED;
   }


   if(Mutilate::leadingZerosS("1235", 3)!="1235")
   {
    $this->e->add("Mutilation leadingZeros with argument \"1235\" failed", "error");
    return UT_FAILED;
   }


   return UT_OK;
  }

  function LeadingZerosArray()
  {
   if(!($values=Mutilate::leadingZerosS(Array(1234), 5)))
   {
    $this->e->add("Mutilation leadingZeros with argument Array(1234) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="01234")
   {
    $this->e->add("Mutilation leadingZeros with argument Array(1234) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }



  function Strip()
  {
   if(Mutilate::stripS("Abcde", 10)!="Abcde")
   {
    $this->e->add("Mutilation strip with argument \"Abcde\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::stripS("Abcdefghij", 10)!="Abcdefghij")
   {
    $this->e->add("Mutilation strip with argument \"Abcdefghij\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::stripS("Abcdefghijk", 10)!="Abcdefg...")
   {
    $this->e->add("Mutilation strip with argument \"Abcdefghijk\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::stripS("Abcdefghijklmnopqrstuvwxyz", 10)!="Abcdefg...")
   {
    $this->e->add("Mutilation strip with argument \"Abcdefghijklmnopqrstuvwxyz\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::stripS("Abcdefghijklmnopqrstuvwxyz", 10, "")!="Abcdefghij")
   {
    $this->e->add("Mutilation strip with argument \"Abcdefghijklmnopqrstuvwxyz\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::stripS("Abcdefghijklmnopqrstuvwxyz", 10, ">")!="Abcdefghi>")
   {
    $this->e->add("Mutilation strip with argument \"Abcdefghijklmnopqrstuvwxyz\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function StripArray()
  {
   if(!($values=Mutilate::stripS(Array("Abcdefghijk"), 6, ">")))
   {
    $this->e->add("Mutilation strip with argument Array(Abcdefghijk) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="Abcde>")
   {
    $this->e->add("Mutilation strip with argument Array(Abcdefghijk) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function Replace()
  {
   if(Mutilate::replaceS("Abcde fghij", "/Abcde/", "EDCBA")!="EDCBA fghij")
   {
    $this->e->add("Mutilation replace with argument \"Abcde fghij\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::replaceS("Abcde fghij", "/Abcde/")!=" fghij")
   {
    $this->e->add("Mutilation replace with argument \"Abcde fghij\" failed", "error");
    return UT_FAILED;
   }


   return UT_OK;
  }

  function ReplaceArray()
  {
   if(!($values=Mutilate::replaceS(Array("Abcdefghijk"), "/Abc/", "ABC")))
   {
    $this->e->add("Mutilation replace with argument Array(Abcdefghijk) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="ABCdefghijk")
   {
    $this->e->add("Mutilation replace with argument Array(Abcdefghijk) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }



  function ChangeCase()
  {
   if(Mutilate::changeCaseS("Abcde fghij", "lower")!="abcde fghij")
   {
    $this->e->add("Mutilation changeCase with argument \"lower\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::changeCaseS("Abcde fghij", "upper")!="ABCDE FGHIJ")
   {
    $this->e->add("Mutilation changeCase with argument \"upper\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::changeCaseS("Abcde Fghij", "first")!="Abcde fghij")
   {
    $this->e->add("Mutilation changeCase with argument \"first\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::changeCaseS("abcde fghij", "words")!="Abcde Fghij")
   {
    $this->e->add("Mutilation changeCase with argument \"words\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::changeCaseS("Abcde fghij", "fail")!="Abcde fghij")
   {
    $this->e->add("Mutilation changeCase with argument \"fail\" failed", "error");
    return UT_FAILED;
   }


   return UT_OK;
  }

  function ChangeCaseArray()
  {
   if(!($values=Mutilate::changeCaseS(Array("Abcdefghijk"), "upper")))
   {
    $this->e->add("Mutilation changeCase with argument Array(Abcdefghijk) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="ABCDEFGHIJK")
   {
    $this->e->add("Mutilation changeCase with argument Array(Abcdefghijk) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function Trim()
  {
   if(Mutilate::trimS("  Abcde fghij  ")!="Abcde fghij")
   {
    $this->e->add("Mutilation trim with default arguments failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::trimS("  Abcde fghij\r\n", false, "left")!="Abcde fghij\r\n")
   {
    $this->e->add("Mutilation trim with argument \"left\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::trimS("  Abcde fghij  \r\n", "\n\r", "end")!="  Abcde fghij  ")
   {
    $this->e->add("Mutilation trim with argument \"end\" failed", "error");
    return UT_FAILED;
   }

   if(Mutilate::trimS("  Abcde\t fghij  \r\n", false, "both")!="Abcde\t fghij")
   {
    $this->e->add("Mutilation trim with argument \"both\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function TrimArray()
  {
   if(!($values=Mutilate::trimS(Array("  Abcde fghij  ", "  Abcde fghij\r\n"))))
   {
    $this->e->add("Mutilation trim with default arguments failed", "error");
    return UT_FAILED;
   }

   if($values[0]!="Abcde fghij")
   {
    $this->e->add("Mutilation trim with default arguments response 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="Abcde fghij")
   {
    $this->e->add("Mutilation trim with default arguments response 2 incorrect", "error");
    return UT_FAILED;
   }

   if(Mutilate::trimS("  Abcde fghij\r\n", false, "left")!="Abcde fghij\r\n")
   {
    $this->e->add("Mutilation trim with argument \"left\" failed", "error");
    return UT_FAILED;
   }

   if(!($values=Mutilate::trimS(Array("  Abcde fghij  ", "  Abcde fghij\r\n", Array("\tAbcde fghij\t", "\rAbcde fghij\r")), " \r\n", "end")))
   {
    $this->e->add("Mutilation trim with argument \"end\" failed", "error");
    return UT_FAILED;
   }

   if($values[0]!="  Abcde fghij")
   {
    $this->e->add("Mutilation trim with argument \"end\" response 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="  Abcde fghij")
   {
    $this->e->add("Mutilation trim with argument \"end\" response 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][0]!="\tAbcde fghij\t")
   {
    $this->e->add("Mutilation trim with argument \"end\" response 3, 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][1]!="\rAbcde fghij")
   {
    $this->e->add("Mutilation trim with argument \"end\" response 3, 2 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function DetectLineBreaks()
  {
   if(($lb=Mutilate::detectLineBreaksS("test1 test2"))!="")
   {
    $this->e->add("Wrong linebreak detected expected: nothing got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }


   if(($lb=Mutilate::detectLineBreaksS("test1\ntest2"))!="\n")
   {
    $this->e->add("Wrong linebreak detected expected: \\n got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("test1\n"))!="\n")
   {
    $this->e->add("Wrong linebreak detected expected: \\n got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("\ntest2"))!="\n")
   {
    $this->e->add("Wrong linebreak detected expected: \\n got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("\n"))!="\n")
   {
    $this->e->add("Wrong linebreak detected expected: \\n got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("\n\n"))!="\n")
   {
    $this->e->add("Wrong linebreak detected expected: \\n got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }


   if(($lb=Mutilate::detectLineBreaksS("test1\rtest2"))!="\r")
   {
    $this->e->add("Wrong linebreak detected expected: \\r got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("test1\r"))!="\r")
   {
    $this->e->add("Wrong linebreak detected expected: \\r got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("\rtest2"))!="\r")
   {
    $this->e->add("Wrong linebreak detected expected: \\r got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("\r"))!="\r")
   {
    $this->e->add("Wrong linebreak detected expected: \\r got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("\r\r"))!="\r")
   {
    $this->e->add("Wrong linebreak detected expected: \\r got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }


   if(($lb=Mutilate::detectLineBreaksS("test1\r\ntest2"))!="\r\n")
   {
    $this->e->add("Wrong linebreak detected expected: \\r\\n got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("test1\r\n"))!="\r\n")
   {
    $this->e->add("Wrong linebreak detected expected: \\r\\n got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("\r\ntest2"))!="\r\n")
   {
    $this->e->add("Wrong linebreak detected expected: \\r\\n got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("\r\n"))!="\r\n")
   {
    $this->e->add("Wrong linebreak detected expected: \\r\\n got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("\r\n\r\n"))!="\r\n")
   {
    $this->e->add("Wrong linebreak detected expected: \\r\\n got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("\n\r\n\r\n"))!="\r\n")
   {
    $this->e->add("Wrong linebreak detected expected: \\r\\n got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }


   if(($lb=Mutilate::detectLineBreaksS("test1\n\rtest2"))!="\n\r")
   {
    $this->e->add("Wrong linebreak detected expected: \\n\\r got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("test1\n\r"))!="\n\r")
   {
    $this->e->add("Wrong linebreak detected expected: \\n\\r got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("\n\rtest2"))!="\n\r")
   {
    $this->e->add("Wrong linebreak detected expected: \\n\\r got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("\n\r"))!="\n\r")
   {
    $this->e->add("Wrong linebreak detected expected: \\n\\r got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("\n\r\n\r"))!="\n\r")
   {
    $this->e->add("Wrong linebreak detected expected: \\n\\r got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   if(($lb=Mutilate::detectLineBreaksS("\r\n\r\n\r"))!="\n\r")
   {
    $this->e->add("Wrong linebreak detected expected: \\n\\r got: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), $lb), "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function DetectLineBreaksArray()
  {
   if(!($values=Mutilate::detectLineBreaksS(Array("Abcde fghij\n", "Abcde fghij\r\n"))))
   {
    $this->e->add("Mutilation detectLineBreaks failed", "error");
    return UT_FAILED;
   }

   if($values[0]!="\n")
   {
    $this->e->add("Mutilation detectLineBreaks response 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="\r\n")
   {
    $this->e->add("Mutilation detectLineBreaks response 2 incorrect", "error");
    return UT_FAILED;
   }

   if(!($values=Mutilate::detectLineBreaksS(Array("Abcde fghij", "Abcde fghij\n\r", Array("Abcde fghij\r", "Abcde fghij\t\r")))))
   {
    $this->e->add("Mutilation detectLineBreaks failed", "error");
    return UT_FAILED;
   }

   if($values[0]!="")
   {
    $this->e->add("Mutilation detectLineBreaks response 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="\n\r")
   {
    $this->e->add("Mutilation detectLineBreaks response 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][0]!="\r")
   {
    $this->e->add("Mutilation detectLineBreaks response 3, 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][1]!="\r")
   {
    $this->e->add("Mutilation detectLineBreaks response 3, 2 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function FixLineBreaks()
  {
   if(Mutilate::fixLineBreaksS("test1 test2")!="test1 test2")
   {
    $this->e->add("No linebreak fixed expected", "error");
    return UT_FAILED;
   }

   if(Mutilate::fixLineBreaksS("test1\r\n test2\r\n")!="test1\n test2\n")
   {
    $this->e->add(str_replace(Array("\n", "\r"), Array("\\n", "\\r"), "\r\n")." should be fixed to: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), "\n"), "error");
    return UT_FAILED;
   }

   if(Mutilate::fixLineBreaksS("test1\r test2\r", "\r\n")!="test1\r\n test2\r\n")
   {
    $this->e->add(str_replace(Array("\n", "\r"), Array("\\n", "\\r"), "\r")." should be fixed to: ".str_replace(Array("\n", "\r"), Array("\\n", "\\r"), "\r\n"), "error");
    return UT_FAILED;
   }

   if(Mutilate::fixLineBreaksS("test1\r\n test2\r\n", "")!="test1 test2")
   {
    $this->e->add(str_replace(Array("\n", "\r"), Array("\\n", "\\r"), "\r\n")." should be removed", "error");
    return UT_FAILED;
   }

   if(Mutilate::fixLineBreaksS("test1\n test2\n", "|")!="test1| test2|")
   {
    $this->e->add(str_replace(Array("\n", "\r"), Array("\\n", "\\r"), "\r\n")." should be fixed to: |", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function FixLineBreaksArray()
  {
   if(!($values=Mutilate::fixLineBreaksS(Array("test1 test2\r", "test1 test2\r\n"))))
   {
    $this->e->add("Mutilation fixLineBreaks with default arguments failed", "error");
    return UT_FAILED;
   }

   if($values[0]!="test1 test2\n")
   {
    $this->e->add("Mutilation fixLineBreaks with default arguments response 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="test1 test2\n")
   {
    $this->e->add("Mutilation fixLineBreaks with default arguments response 2 incorrect", "error");
    return UT_FAILED;
   }

   if(!($values=Mutilate::fixLineBreaksS(Array("test1 test2\r", "test1 test2\r\n", Array("test1\r test2\r", "test1\r\r test2\r\r")), "|")))
   {
    $this->e->add("Mutilation fixLineBreaks with | argument failed", "error");
    return UT_FAILED;
   }

   if($values[0]!="test1 test2|")
   {
    $this->e->add("Mutilation fixLineBreaks with | argument response 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[1]!="test1 test2|")
   {
    $this->e->add("Mutilation fixLineBreaks with | argument response 2 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][0]!="test1| test2|")
   {
    $this->e->add("Mutilation fixLineBreaks with | argument response 3, 1 incorrect", "error");
    return UT_FAILED;
   }
   if($values[2][1]!="test1|| test2||")
   {
    $this->e->add("Mutilation fixLineBreaks with | argument response 3, 2 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function StripTags()
  {
   if(Mutilate::stripTagsS("Abcde<br/><a href=\"\">fghij</a>")!="Abcdefghij")
   {
    $this->e->add("Mutilation stripTags with argument \"Abcde<br/><a href=\"\">fghij</a>\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function StripTagsArray()
  {
   if(!($values=Mutilate::stripTagsS(Array("Abcde<br/>fghijk"))))
   {
    $this->e->add("Mutilation stripTags with argument Array(Abcde<br/>fghijk) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="Abcdefghijk")
   {
    $this->e->add("Mutilation stripTags with argument Array(Abcde<br/>fghijk) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function HTMLEncode()
  {
   if(Mutilate::htmlEncodeS("Abcde<br/><a href=\"\">fghij</a>")!="Abcde&lt;br/&gt;&lt;a href=&quot;&quot;&gt;fghij&lt;/a&gt;")
   {
    $this->e->add("Mutilation stripTags with argument \"Abcde<br/><a href=\"\">fghij</a>\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function HTMLEncodeArray()
  {
   if(!($values=Mutilate::htmlEncodeS(Array("Abcde<br/>fghijk"))))
   {
    $this->e->add("Mutilation htmlEncode with argument Array(Abcde<br/>fghijk) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="Abcde&lt;br/&gt;fghijk")
   {
    $this->e->add("Mutilation htmlEncode with argument Array(Abcde<br/>fghijk) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function HTMLDecode()
  {
   if(Mutilate::htmlDecodeS("Abcde&lt;br/&gt;&lt;a href=&quot;&quot;&gt;fghij&lt;/a&gt;")!="Abcde<br/><a href=\"\">fghij</a>")
   {
    $this->e->add("Mutilation stripTags with argument \"Abcde&lt;br/&gt;&lt;a href=&quot;&quot;&gt;fghij&lt;/a&gt;\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function HTMLDecodeArray()
  {
   if(!($values=Mutilate::htmlDecodeS(Array("Abcde&lt;br/&gt;fghijk"))))
   {
    $this->e->add("Mutilation htmlDecode with argument Array(Abcde&lt;br/&gt;fghijk) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="Abcde<br/>fghijk")
   {
    $this->e->add("Mutilation htmlDecode with argument Array(Abcde&lt;br/&gt;fghijk) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function MarkupEncode()
  {
   global $_config;

   $this->_init();

   $useModRewrite=$_config->get("useModRewrite"); //save rewrite

   foreach($this->markupTests as $test)
   {
    if(isset($test["rewrite"])) //set rewrite
     $_config->set("useModRewrite", $test["rewrite"]);

    if(($output=Mutilate::markupEncodeS($test["h"], (isset($test["short"])&&$test["short"])))===false) //get result
    {
     $this->e->add("Markup encode shouldn't have failed on ".$test["t"], "error");

     $_config->set("useModRewrite", $useModRewrite); //restore rewrite
     return UT_FAILED;
    }

    //fix expected output
    $test["m"]=preg_replace("/(\w+=)(\"([^\"\s]+)\"|'([^'\s]+)')/", "\\1\\3\\4", $test["m"]); //strip quotes from single word attributes
    $test["m"]=preg_replace("/(\w+=)'([^']+)'/", "\\1\"\\2\"", $test["m"]); //convert ' to "
    $test["m"]=preg_replace("/ \w+=\"\"/", "", $test["m"]); //remove empty attributes

    if(!$this->_compare($output, $test["m"])) //compare to expected output
    {
     $this->e->add("Markup encode doesn't match expected output for ".$test["t"], "error");

     $_config->set("useModRewrite", $useModRewrite); //restore rewrite
     return UT_FAILED;
    }
   }

   $_config->set("useModRewrite", $useModRewrite); //restore rewrite


   return UT_OK;
  }

  function MarkupDecode()
  {
   global $_config;

   $this->_init();

   $useModRewrite=$_config->get("useModRewrite"); //save rewrite

   foreach($this->markupTests as $test)
   {
    if(isset($test["rewrite"])) //set rewrite
     $_config->set("useModRewrite", $test["rewrite"]);

    if(($output=Mutilate::markupDecodeS($test["m"]))===false) //get result
    {
     $this->e->add("Markup decode shouldn't have failed on ".$test["t"], "error");

     $_config->set("useModRewrite", $useModRewrite); //restore rewrite
     return UT_FAILED;
    }

    if(!$this->_compare($output, $test["h"])) //compare to expected output
    {
     $this->e->add("Markup decode doesn't match expected output for ".$test["t"], "error");

     $_config->set("useModRewrite", $useModRewrite); //restore rewrite
     return UT_FAILED;
    }
   }

   $_config->set("useModRewrite", $useModRewrite); //restore rewrite


   return UT_OK;
  }


  function URLEncode()
  {
   $this->_init();

   foreach($this->urlTests as $url)
   {
    if(Mutilate::urlEncodeS($url["decoded"])!=$url["encoded"])
    {
     $this->e->add("Mutilation urlEncode with argument \"".$url["decoded"]."\" failed", "error");
     return UT_FAILED;
    }
   }

   return UT_OK;
  }

  function URLEncodeArray()
  {
   $this->_init();

   $decoded=Array();
   $encoded=Array();
   foreach($this->urlTests as $url)
   {
    $decoded[]=$url["decoded"];
    $encoded[]=$url["encoded"];
   }

   if(!($values=Mutilate::urlEncodeS($decoded)))
   {
    $this->e->add("Mutilation urlEncode with array argument failed", "error");
    return UT_FAILED;
   }

   if(!$this->_compare($encoded, $values))
    return UT_FAILED;

   return UT_OK;
  }


  function URLDecode()
  {
   $this->_init();

   foreach($this->urlTests as $url)
   {
    if(Mutilate::urlDecodeS($url["encoded"])!=$url["decoded"])
    {
     $this->e->add("Mutilation urlDecode with argument \"".$url["decoded"]."\" failed", "error");
     return UT_FAILED;
    }
   }

   return UT_OK;
  }

  function URLDecodeArray()
  {
   $this->_init();

   $decoded=Array();
   $encoded=Array();
   foreach($this->urlTests as $url)
   {
    $decoded[]=$url["decoded"];
    $encoded[]=$url["encoded"];
   }

   if(!($values=Mutilate::urlDecodeS($encoded)))
   {
    $this->e->add("Mutilation urlDecode with array argument failed", "error");
    return UT_FAILED;
   }

   if(!$this->_compare($decoded, $values))
    return UT_FAILED;

   return UT_OK;
  }


  function Base64Encode()
  {
   $this->_init();

   foreach($this->base64Tests as $base64)
   {
    if(Mutilate::base64EncodeS($base64["decoded"])!=$base64["encoded"])
    {
     $this->e->add("Mutilation base64Encode with argument \"".$base64["decoded"]."\" failed", "error");
     return UT_FAILED;
    }
   }

   return UT_OK;
  }

  function Base64EncodeArray()
  {
   $this->_init();

   $decoded=Array();
   $encoded=Array();
   foreach($this->base64Tests as $base64)
   {
    $decoded[]=$base64["decoded"];
    $encoded[]=$base64["encoded"];
   }

   if(!($values=Mutilate::base64EncodeS($decoded)))
   {
    $this->e->add("Mutilation base64Encode with array argument failed", "error");
    return UT_FAILED;
   }

   if(!$this->_compare($encoded, $values))
    return UT_FAILED;

   return UT_OK;
  }


  function Base64Decode()
  {
   $this->_init();

   foreach($this->base64Tests as $base64)
   {
    if(Mutilate::base64DecodeS($base64["encoded"])!=$base64["decoded"])
    {
     $this->e->add("Mutilation base64Decode with argument \"".$base64["decoded"]."\" failed", "error");
     return UT_FAILED;
    }
   }

   return UT_OK;
  }

  function Base64DecodeArray()
  {
   $this->_init();

   $decoded=Array();
   $encoded=Array();
   foreach($this->base64Tests as $base64)
   {
    $decoded[]=$base64["decoded"];
    $encoded[]=$base64["encoded"];
   }

   if(!($values=Mutilate::base64DecodeS($encoded)))
   {
    $this->e->add("Mutilation base64Decode with array argument failed", "error");
    return UT_FAILED;
   }

   if(!$this->_compare($decoded, $values))
    return UT_FAILED;

   return UT_OK;
  }


  function ScrambleEmail()
  {
   if(Mutilate::scrambleEmailS("you@me.come")!="you(at)me[dot]come")
   {
    $this->e->add("Mutilation scrambleEmail with argument \"you@me.come\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function ScrambleEmailArray()
  {
   if(!($values=Mutilate::scrambleEmailS(Array("you@me.come"))))
   {
    $this->e->add("Mutilation scrambleEmail with argument Array(you@me.come) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="you(at)me[dot]come")
   {
    $this->e->add("Mutilation scrambleEmail with argument Array(you@me.come) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function UnScrambleEmail()
  {
   if(Mutilate::unscrambleEmailS("you(at)me[dot]come")!="you@me.come")
   {
    $this->e->add("Mutilation unscrambleEmail with argument \"you(at)me[dot]come\" failed", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function UnScrambleEmailArray()
  {
   if(!($values=Mutilate::unscrambleEmailS(Array("you(at)me[dot]come"))))
   {
    $this->e->add("Mutilation unscrambleEmail with argument Array(you(at)me[dot]come) failed", "error");
    return UT_FAILED;
   }
   if($values[0]!="you@me.come")
   {
    $this->e->add("Mutilation unscrambleEmail with argument Array(you(at)me[dot]come) argument 1 incorrect", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

 }
?>
