<?

 /*****************************************************************************
 * Filename: project/jas/include/backend/cms.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["project"]["include"]."backend/base.php");
 require_once($_path["include"]."history.php");
 require_once($_path["include"]."data.php");
 require_once($_path["include"]."cms.php");

 class Backend_Cms extends Backend_Base
 {
  function __construct(&$backend)
  {
   parent::__construct($backend);

   $this->reload=false;
  }

  function main($module=false, $action=false, $extra=false, $nr=false)
  {
   global $_session;

   $_session->frontend();

   $this->language->read("cms");

   $this->cms=new CMS(Array(
    "handleSubmit" => false,
    "showErrors" => false,
    "showTitles" => false,
   ));

   if(!$this->backend->rewrite) //vars
    foreach($this->backend->pageVars as $k => $page)
     $this->cms->addVar("p[".$k."]", $page);

   //set page as CMS in history
   $hs=new History();
   if(!$hs->cms())
    $this->e->add($hs->e);

   //init data
   $d=Data::cache($module, $action, $extra);

   if(($id=$d->getID())&&$nr!==false&&!$d->check("valuetype", "request", $id))
    $d->setValue($id, $nr);

   $this->cms->setDataForm($d, $this->form);

   //submit cms
   if($this->cms->formHandleSubmit()) //submit successful
    if(!request("cmsContinue")) //no more cms action?
     $this->reload=$this->cms->handleReloadPage();

   $_session->backend();
   return true;
  }


  /*
   * Output
   */

  function output_default()
  {
   global $_session;

   $_session->frontend();

   $this->backend->setTitle($this->icon("cms_dim"),
    $this->link($this->language->t("CMS"), Array("modules/")),
    $this->link($this->language->t(ucfirst($this->cms->data->action)), $this->url()),
    $this->link($this->cms->data->l->t($this->cms->data->title), Array("modules/".$this->cms->data->module."/")));

   if($this->reload)
   {
    $this->e->add($this->cms->e);

    $_session->backend();
    return $this->reload;
   }

   $r=$this->cms->form();
   $this->e->add($this->cms->e);

   $_session->backend();
   return $r;
  }
 }
?>
