<?

 /*****************************************************************************
 * Filename: project/jas/include/backend/navigation.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["project"]["include"]."backend/base.php");

 class Backend_Navigation extends Backend_Base
 {
  function __construct(&$backend)
  {
   parent::__construct($backend);
  }

  function main($section=false)
  {
   //section
   if(!parent::main($section))
    return false;

   return true;
  }


  /*
   * Output
   */

  function output_default()
  {
   if($entries=$this->navigation("navigation"))
    foreach($entries as $entry)
     $this->menuItem("nav", $entry["title"], $this->url($entry["path"]), $entry["title"], $entry["icon"]);

   return $this->menu("nav");
  }


  /*
   * Support
   */

  static function navigation($section)
  {
   global $_session, $_config, $_Backend_Naviggation, $backend;

   $sections=Array( //hardcoded
    "navigation" => 3,
    "home" => 4,
   );

   if(!isset($sections[$section]))
    return false;

   if(isset($_Backend_Naviggation[$section]))
    return $_Backend_Naviggation[$section];

   $d=Data::cache("links", "view", "list");
   $d->setShowFields("title", "path", "icon", "translate", "rootonly");

   $d->clearValues();
   $d->setValue("catnr", $sections[$section]);

   if(!$d->get())
    return false;

   $_session->frontend();

   $_Backend_Naviggation[$section]=Array();
   while($d->next())
   {
    if($d->v["rootonly"]&&!$_config->userRoot())
     continue;

    $_Backend_Naviggation[$section][]=Array(
     "title" => ($d->v["translate"]?$backend->language->t($d->v["title"]):$d->v["title"]),
     "path" => $d->v["path"],
     "icon" => $d->v["icon"],
    );
   }

   $_session->backend();

   return $_Backend_Naviggation[$section];
  }
 }
?>
