

 /*****************************************************************************
 * Filename: script/wysiwyg.js
 *
 * This file is part of the JAS project.
 * Copyright 2003-2015 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


if(typeof(browser)=="undefined"||typeof(path)=="undefined"||typeof(rootpath)=="undefined")
 alert("JAS Script not loaded");
else if(typeof(onload)!='function')
 alert("Script not loaded: functions.js");
else if(typeof(setGetElementFunctions)!="function")
 alert("Script not loaded: getelements.js");
else if(typeof(Selection)!='function'||!Selection.toString().match(/function _getID/))
 alert("Script not loaded: selection.js");
else
 onload("initWYSIWYG();");

function initWYSIWYG()
{
 setGetElementFunctions();

 var tmp=document.getElementsByClassName("wysiwyg");

 wysiwygs=Array();
 for(var c=0;c<tmp.length;c++)
  wysiwygs[c]=new WYSIWYG(tmp[c], c);
}

function WYSIWYG(textarea, id)
{
 var self=this;

 self.textarea=textarea;
 self.id=id;

 self.init=init;
 self.sync=sync;
 self.hide=hide;
 self.show=show;
 self.showPopup=showPopup;
 self.view=view;
 self.error=error;

 self.ieOnload=ieOnload;
 self.getRootFolder=getRootFolder;

 self.selection=new Selection();
 self.detectTag=detectTag;

 self.clean=clean;
 self.cmd=cmd;
 self.cmdTag=cmdTag;

 self.fontSize=fontSize;

 self.unsetLink=unsetLink;
 self.formSetLink=formSetLink;
 self.setLink=setLink;
 self.formSetEmailLink=formSetEmailLink;
 self.setEmailLink=setEmailLink;
 self.formSetFileLink=formSetFileLink;
 self.setFileLink=setFileLink;
 self.formSetImage=formSetImage;
 self.setImage=setImage;

 self.showSpecialchars=showSpecialchars;
 self.showLinks=showLinks;
 self.showEmail=showEmail;
 self.showFiles=showFiles;
 self.showImages=showImages;

 self.addOption=addOption;
 self.editOption=editOption;
 self.cmdOption=cmdOption;

 self.iframeEvent=iframeEvent;
 self.textareaEvent=textareaEvent;

 self.loadConfig=loadConfig;
 self.loadSpecialCharacters=loadSpecialCharacters;
 self.loadFilesList=loadFilesList;
 self.loadImagesList=loadImagesList;
 self.loadTranslations=loadTranslations;

 self.config=Array()
 self.config["translate"]=0;
 self.config["modRewrite"]=0;

 self.config["bold"]=1;
 self.config["italic"]=1;
 self.config["underline"]=1;
 self.config["strikeThrough"]=1;

 self.config["h1"]=1;
 self.config["h2"]=1;
 self.config["h3"]=1;
 self.config["h4"]=1;
 self.config["h5"]=1;
 self.config["h6"]=1;
 self.config["paragraph"]=1;

 self.config["bulletList"]=1;
 self.config["numberList"]=1;

 self.config["outdent"]=1;
 self.config["indent"]=1;

 self.config["alignLeft"]=1;
 self.config["alignCenter"]=1;
 self.config["alignRight"]=1;

 self.config["removeFormat"]=1;
 self.config["specialCharacters"]=1;

 self.config["links"]=1;
 self.config["email"]=1;

 self.config["files"]=0;
 self.config["filesModules"]=Array("files");

 self.config["images"]=0;
 self.config["imagesModules"]=Array("images");
 self.config["imagesThumbWidth"]=100;
 self.config["imagesDefaultWidth"]=400;

 self.config["undo"]=1;
 self.config["redo"]=1;

 self.config["copy"]=1;
 self.config["paste"]=1;
 self.config["cut"]=1;
 self.config["delete"]=1;

 self.config["iframe"]=1;
 self.config["textarea"]=1;
 self.config["fullscreen"]=1;

 self.config["fontsize"]=1;

 self.init();

 function init()
 {
  self.lang=Object();
  self.lang.t=function (t){return t;}; //overwritten when translations is loaded

  self.height=self.textarea.offsetHeight;
  self.width=self.textarea.offsetWidth;
  self.heightStatic=self.height;
  self.widthStatic=self.width;

  self.textarea.style.display="none";

  //iframe
  self.iframe=document.createElement("iframe");
  self.iframe.className="wysiwygIframe form";
  self.iframe.style.borderWidth="1px";
  self.iframe.style.display="none";

  self.textarea.parentNode.insertBefore(self.iframe, self.textarea);


  //option window
  self.options=document.createElement("div");
  self.options.className="wysiwygOptions";

  self.options.list=Array();

  self.iframe.parentNode.insertBefore(self.options, self.iframe);


  //error window
  self.errorWindow=document.createElement("div");
  self.errorWindow.className="wysiwygErrorWindow form";
  self.errorWindow.style.border="1px solid red";
  self.errorWindow.style.padding="2px";
  self.errorWindow.style.display="none";
  self.errorWindow.innerHTML="<img src=\""+rootpath+"images/wysiwyg/close.png\" alt=\"Close\" style=\"float: right;\" onclick=\"wysiwygs["+self.id+"].hide('error'); this.parentNode.lastChild.innerHTML='';\"/>\n<div></div>";

  self.textarea.parentNode.insertBefore(self.errorWindow, self.iframe);


  //popup
  self.popup=document.createElement("div");
  self.popup.className="wysiwygPopup";
  self.popup.style.border="1px solid gray";
  self.popup.style.overflow="auto";
  self.popup.style.display="none";
  self.popup.innerHTML="<img src=\""+rootpath+"images/wysiwyg/close.png\" alt=\"Close\" style=\"float: right;\" onclick=\"wysiwygs["+self.id+"].hide('popup');\"/>";

  self.textarea.parentNode.insertBefore(self.popup, self.iframe);

  //popup special characters
  self.popup.specialchar=document.createElement("div");
  self.popup.specialchar.wysiwyg=self;
  self.popup.specialchar.className="wysiwygPopupSpecialchar";
  self.popup.specialchar.innerHTML="No special characters available";

  self.popup.appendChild(self.popup.specialchar);

  //popup links
  self.popup.links=document.createElement("div");
  self.popup.links.wysiwyg=self;
  self.popup.links.className="wysiwygPopupLinks";

  var tmp="";
  tmp+="<div class=\"field\"><div class=\"title\">Link address</div><div class=\"input\"><input class=\"form text\" type=\"text\" id=\"linknormal\" value=\"\" onchange=\"wysiwygs["+self.id+"].formSetLink();\" /></div></div>";
  tmp+="<div class=\"field\"><div class=\"title\">Title</div><div class=\"input\"><input class=\"form text\" type=\"text\" id=\"linknormaltitle\" value=\"\" onchange=\"wysiwygs["+self.id+"].formSetLink();\" /></div></div>";
  tmp+="<div class=\"field\"><div class=\"title\">Target</div><div class=\"input\"><select class=\"form select\" id=\"linknormaltarget\" onchange=\"wysiwygs["+self.id+"].formSetLink();\"><option value=\"\"><option value=\"popup\">Popup<option value=\"external\">External<option value=\"_blank\">Blank</select></div></div>";
  self.popup.links.innerHTML=tmp;

  self.popup.appendChild(self.popup.links);


  //popup email
  self.popup.email=document.createElement("div");
  self.popup.email.wysiwyg=self;
  self.popup.email.className="wysiwygPopupEmail";

  var tmp="";
  tmp+="<div class=\"field\"><div class=\"title\">E-mail address</div><div class=\"input\"><input class=\"form text\" type=\"text\" id=\"linkemail\" value=\"\" onchange=\"wysiwygs["+self.id+"].formSetEmailLink();\" /></div></div>";
  tmp+="<div class=\"field\"><div class=\"title\">Title</div><div class=\"input\"><input class=\"form text\" type=\"text\" id=\"linkemailtitle\" value=\"\" onchange=\"wysiwygs["+self.id+"].formSetEmailLink();\" /></div></div>";
  self.popup.email.innerHTML=tmp;

  self.popup.appendChild(self.popup.email);


  //popup files
  self.popup.files=document.createElement("div");
  self.popup.files.wysiwyg=self;
  self.popup.files.className="wysiwygPopupFiles";
  self.popup.files.innerHTML="No files available";

  self.popup.appendChild(self.popup.files);


  //popup filesEdit
  self.popup.filesEdit=document.createElement("div");
  self.popup.filesEdit.wysiwyg=self;
  self.popup.filesEdit.className="wysiwygPopupLinks";

  var tmp="";
  tmp+="<div class=\"field\"><div class=\"title\">File</div><div class=\"input\"><select class=\"form select\" id=\"filenr\" onchange=\"wysiwygs["+self.id+"].formSetFileLink();\"><option value=\"\">No files</select></div></div>";
  tmp+="<div class=\"field\"><div class=\"title\">Title</div><div class=\"input\"><input class=\"form text\" type=\"text\" id=\"filetitle\" value=\"\" onchange=\"wysiwygs["+self.id+"].formSetFileLink();\" /></div></div>";
  tmp+="<div class=\"field\"><div class=\"title\">Target</div><div class=\"input\"><select class=\"form select\" id=\"filetarget\" onchange=\"wysiwygs["+self.id+"].formSetFileLink();\"><option value=\"\"><option value=\"popup\">Popup<option value=\"external\">External<option value=\"_blank\">Blank</select></div></div>";
  self.popup.filesEdit.innerHTML=tmp;

  self.popup.appendChild(self.popup.filesEdit);


  //popup images
  self.popup.images=document.createElement("div");
  self.popup.images.wysiwyg=self;
  self.popup.images.className="wysiwygPopupImages";
  self.popup.images.innerHTML="No images available";

  self.popup.appendChild(self.popup.images);


  //popup imagesEdit
  self.popup.imagesEdit=document.createElement("div");
  self.popup.imagesEdit.wysiwyg=self;
  self.popup.imagesEdit.className="wysiwygPopupLinks";

  var tmp="";
  tmp+="<div class=\"field\"><div class=\"title\">Image</div><div class=\"input\"><input type=\"hidden\" id=\"imagemodule\" value=\"\"/><img src=\"\" value=\"\" style=\"width: 100px;\" id=\"imagenr\"/></div></div>";
  tmp+="<div class=\"field\"><div class=\"title\">Alt text</div><div class=\"input\"><input class=\"form text\" type=\"text\" id=\"imagealt\" value=\"\" onchange=\"wysiwygs["+self.id+"].formSetImage();\" /></div></div>";
  tmp+="<div class=\"field\"><div class=\"title\">Size</div><div class=\"input\">";
  tmp+="<input class=\"form text\" type=\"text\" style=\"width: 100px;\" id=\"imagewidth\" value=\"\" onchange=\"if(document.getElementById('imagescalelock').checked){document.getElementById('imageheight').value='';} wysiwygs["+self.id+"].formSetImage();\" /> x ";
  tmp+="<input class=\"form text\" type=\"text\" style=\"width: 100px;\" id=\"imageheight\" value=\"\" onchange=\"if(document.getElementById('imagescalelock').checked){document.getElementById('imagewidth').value='';} wysiwygs["+self.id+"].formSetImage();\" /> ";
  tmp+="<label for=\"imagescalelock\"><input class=\"form checkbox\" type=\"checkbox\" id=\"imagescalelock\" value=\"1\" onchange=\"wysiwygs["+self.id+"].formSetImage();\" /> Lock scale</label>";
  tmp+="</div></div>";
  tmp+="<div class=\"field\"><div class=\"title\">Rotate</div><div class=\"input\"><select class=\"form select\" style=\"width: 100px;\" id=\"imagerotate\" onchange=\"wysiwygs["+self.id+"].formSetImage();\"><option value=\"\"><option value=\"left\">Left<option value=\"right\">Right<option value=\"180\">180</select></div></div>";
  self.popup.imagesEdit.innerHTML=tmp;

  self.popup.appendChild(self.popup.imagesEdit);


  //create iframe document header (style+meta elements)
  var header="";
  var headElements=document.getElementsByTagName("head")[0].getElementsByTagName("meta");
  for(var c=0;c<headElements.length;c++)
   header+=headElements[c].outerHTML;

  var headElements=document.getElementsByTagName("head")[0].getElementsByTagName("link");
  for(var c=0;c<headElements.length;c++)
   header+=headElements[c].outerHTML;

  //wysiwyg object
  self.wysiwyg=self.iframe.contentWindow.document;
  self.wysiwyg.writeln("<html>");
  self.wysiwyg.writeln(" <head>"+header+"</head>");
  self.wysiwyg.writeln(" <body></body>");
  self.wysiwyg.writeln("</html>");

  //enable design mode
  if(!self.textarea.disabled)
   self.wysiwyg.designMode="on";

  //add event functions to iframe
  self.wysiwyg.addEvent=self.iframe.addEvent;
  self.wysiwyg.removeEvent=self.iframe.removeEvent;


  //load configuration
  self.loadConfig();

  //add options
  if(self.config["bold"]) self.addOption("bold", "bold", "Bold", self.cmdOption);
  if(self.config["italic"]) self.addOption("italic", "italic", "Italic", self.cmdOption);
  if(self.config["underline"]) self.addOption("underline", "underline", "Underline", self.cmdOption);
  if(self.config["strikeThrough"]) self.addOption("strikeThrough", "strikeThrough", "Strike through", self.cmdOption);
  if(self.config["bold"]||self.config["italic"]||self.config["underline"]||self.config["strikeThrough"]) self.addOption("spacer");

  if(self.config["h1"]) self.addOption("formatBlock", "h1", "Header 1", self.cmdOption);
  if(self.config["h2"]) self.addOption("formatBlock", "h2", "Header 2", self.cmdOption);
  if(self.config["h3"]) self.addOption("formatBlock", "h3", "Header 3", self.cmdOption);
  if(self.config["h4"]) self.addOption("formatBlock", "h4", "Header 4", self.cmdOption);
  if(self.config["h5"]) self.addOption("formatBlock", "h5", "Header 5", self.cmdOption);
  if(self.config["h6"]) self.addOption("formatBlock", "h6", "Header 6", self.cmdOption);
  if(self.config["paragraph"]) self.addOption("formatBlock", "p", "Paragraph", self.cmdOption);
  if(self.config["h1"]||self.config["h2"]||self.config["h3"]||self.config["h4"]||self.config["h5"]||self.config["h6"]||self.config["paragraph"]) self.addOption("spacer");

  if(self.config["bulletList"]) self.addOption("insertUnorderedList", "bulletlist", "Bullet list", self.cmdOption);
  if(self.config["numberList"]) self.addOption("insertOrderedList", "numberlist", "Number list", self.cmdOption);
  if(self.config["bulletList"]||self.config["numberList"]) self.addOption("spacer");

  if(self.config["outdent"]) self.addOption("outdent", "outdent", "Outdent", self.cmdOption);
  if(self.config["indent"]) self.addOption("indent", "indent", "Indent", self.cmdOption);
  if(self.config["outdent"]||self.config["indent"]) self.addOption("spacer");

  if(self.config["alignLeft"]) self.addOption("justifyLeft", "alignLeft", "Align left", self.cmdOption);
  if(self.config["alignCenter"]) self.addOption("justifyCenter", "alignCenter", "Align center", self.cmdOption);
  if(self.config["alignRight"]) self.addOption("justifyRight", "alignRight", "Align right", self.cmdOption);
  if(self.config["alignLeft"]||self.config["justifyCenter"]||self.config["justifyRight"]) self.addOption("spacer");

  if(self.config["removeFormat"]) self.addOption("removeFormat", "clear", "Clear formatting", self.cmdOption);
  if(self.config["removeFormat"]) self.addOption("spacer");

  if(self.config["specialCharacters"]) self.addOption("specialchar", "specialchar", "Special characters", self.showSpecialchars);
  if(self.config["specialCharacters"]) self.addOption("spacer");

  self.addOption("break");

  if(self.config["links"]) self.addOption("links", "links", "Show links popup", self.showLinks);
  if(self.config["links"]) self.addOption("linksRemove", "linksRemove", "Remove link", self.unsetLink);
  if(self.config["email"]) self.addOption("email", "email", "Show e-mail popup", self.showEmail);
  if(self.config["files"]) self.addOption("files", "files", "Show files popup", self.showFiles);
  if(self.config["images"]) self.addOption("images", "images", "Show images popup", self.showImages);
  if(self.config["links"]||self.config["email"]||self.config["files"]||self.config["images"]) self.addOption("spacer");

  if(self.config["undo"]) self.addOption("undo", "undo", "Undo", self.cmdOption);
  if(self.config["redo"]) self.addOption("redo", "redo", "Redo", self.cmdOption);
  if(self.config["undo"]||self.config["redo"]) self.addOption("spacer");

  if(self.config["copy"]) self.addOption("copy", "copy", "Copy", self.cmdOption);
  if(self.config["paste"]) self.addOption("paste", "paste", "Paste", self.cmdOption);
  if(self.config["cut"]) self.addOption("cut", "cut", "Cut", self.cmdOption);
  if(self.config["delete"]) self.addOption("delete", "delete", "Delete", self.cmdOption);
  if(self.config["copy"]||self.config["paste"]||self.config["cut"]||self.config["delete"]) self.addOption("spacer");

  if(self.config["iframe"]) self.addOption("hideIframe", "hideIframe", "Hide WYSIWYG", self.hide);
  if(self.config["textarea"]) self.addOption("hideTextarea", "hideTextarea", "Hide Textarea", self.hide);
  if(self.config["fullscreen"]) self.addOption("view", "viewLarge", "Show large", self.view);
  if(self.config["iframe"]||self.config["textarea"]||self.config["fullscreen"]) self.addOption("spacer");

  if(self.config["fontsize"])
  {
   var tmp=document.createElement("select");
   tmp.style.fontSize="12px";
   tmp.style.width="50px";
   tmp.id="fontsize";

   tmp.options[tmp.options.length]=new Option("", "");
   for(c=6;c<=36;c+=2)
    tmp.options[tmp.options.length]=new Option(c, c+"pt");

   self.options.appendChild(tmp);
   tmp.addEvent("change", self.fontSize);
  }

  //add events
  self.wysiwyg.addEvent("keyup", self.iframeEvent);
  self.wysiwyg.addEvent("mouseup", self.iframeEvent);
  self.wysiwyg.addEvent("dblclick", self.iframeEvent);
  self.textarea.addEvent("keyup", self.textareaEvent);
  self.textarea.addEvent("mouseup", self.textareaEvent);
  self.textarea.form.addEvent("submit", self.iframeEvent);

  //setup screen
  //self.hide("error");
  self.hide("popup");
  self.hide("textarea");
  self.clean("textarea");
  self.show("iframe");

  //ie hack
  if(browser.match(/internet explorer/i))
  {
   setGetElementFunctions();
   self.ieOnload();
  }
  else
   self.sync("iframe");

  //load stuff
  if(self.config["translate"])
   self.loadTranslations();

  if(self.config["specialCharacters"])
   self.loadSpecialCharacters();

  if(self.config["files"])
   self.loadFilesList();

  if(self.config["images"])
   self.loadImagesList();


  return true;
 }

 function sync(type)
 {
  switch(type)
  {
   case "iframe":
   {
    self.wysiwyg.body.innerHTML=self.textarea.value;
    break;
   }
   case "textarea":
   {
    self.textarea.value=self.wysiwyg.body.innerHTML;
    break;
   }
   default:
   {
    self.error("Can't sync type: "+type);
    return false;
   }
  }

  return true;
 }


//DISPLAYING


 function hide(e)
 {
  if(typeof(e)=="string")
   type=e;
  else
  {
   if(option=(e.target||e.srcElement))//real e
   {
    if(option.img.match(/textarea/i))
     type="textarea";
    else if(option.img.match(/iframe/i))
     type="iframe";
    else
     type="unknown";
   }
  }

  if(
    type!="unknown"&&type!="error"&&
    self.iframe.style.display!="none"&&(self.textarea.style.display!="none"||self.popup.style.display!="none"))
  {
   self.textarea.style.height=self.height+"px";
   self.iframe.style.height=self.height+"px";
  }

  switch(type)
  {
   case "iframe":
   {
    self.iframe.style.display="none";

    if(typeof(self.options.list["hideIframe"])!="undefined")
    {
     self.options.list["hideIframe"].removeEvent("click", self.hide);
     self.editOption("hideIframe", "showIframe", "Show WYSIWYG", self.show);
    }

    if(self.textarea.style.display=="none")
     self.show("textarea")

    break;
   }
   case "textarea":
   {
    self.textarea.style.display="none";

    if(typeof(self.options.list["hideTextarea"])!="undefined")
    {
     self.options.list["hideTextarea"].removeEvent("click", self.hide);
     self.editOption("hideTextarea", "showTextarea", "Show Textarea", self.show);
    }


    if(self.iframe.style.display=="none")
     self.show("iframe")

    break;
   }
   case "popup":
   {
    self.popup.style.display="none";
    break;
   }
   case "error":
   {
    self.errorWindow.style.display="none";
    break;
   }
   default:
   {
    self.error("Can't hide type: "+type);
    return false;
   }
  }
 }

 function show(e)
 {
  if(typeof(e)=="string")
   type=e;
  else
  {
   if(option=(e.target||e.srcElement))//real e
   {
    if(option.img.match(/textarea/i))
     type="textarea";
    else if(option.img.match(/iframe/i))
     type="iframe";
    else
     type="unknown";
   }
  }

  switch(type)
  {
   case "iframe":
   {
    self.iframe.style.display="block";

    if(typeof(self.options.list["hideIframe"])!="undefined")
    {
     self.options.list["hideIframe"].removeEvent("click", self.show);
     self.editOption("hideIframe", "hideIframe", "Hide WYSIWYG", self.hide);
    }
    break;
   }
   case "textarea":
   {
    self.textarea.style.display="block";

    if(typeof(self.options.list["hideTextarea"])!="undefined")
    {
     self.options.list["hideTextarea"].removeEvent("click", self.show);
     self.editOption("hideTextarea", "hideTextarea", "Hide Textarea", self.hide);
    }
    break;
   }
   case "popup":
   {
    self.popup.style.display="block";

    if(self.iframe.style.display=="none")
     self.show("iframe")

    break;
   }
   case "error":
   {
    self.errorWindow.style.display="block";
    break;
   }
   default:
   {
    self.error("Can't show type: "+type);
    return false;
   }
  }

  if(self.iframe.style.display!="none"&&self.textarea.style.display!="none")
  {
   self.textarea.style.height=(self.height/2)+"px";
   self.iframe.style.height=(self.height/2)+"px";
  }
  else
  {
   self.textarea.style.height=self.height+"px";
   self.iframe.style.height=self.height+"px";
  }

  if(self.popup.style.display!="none")
  {
   self.popup.style.height=(self.height/2)+"px";
  }
 }

 function showPopup(popup)
 {
  for(var c=0;c<self.popup.childNodes.length;c++)
   if(self.popup.childNodes[c].className.match(/^wysiwygPopup/))
    self.popup.childNodes[c].style.display="none";

  sub=eval("self.popup."+popup);
  sub.style.display="block";

  self.show("popup")
 }

 function view(e)
 {
  if(typeof(e)=="string")
   type=e;
  else
  {
   if(option=(e.target||e.srcElement))//real e
   {
    if(option.img.match(/large/i))
     state="large";
    else if(option.img.match(/normal/i))
     state="normal";
    else
     state="unknown";
   }
  }

  var container=self.textarea.parentNode.parentNode;

  if(state=="normal")
  {
   container.style.position="relative";
   container.style.backgroundColor="";
   container.style.width="100%";
   container.style.height="100%";
   container.style.zIndex="0";

   self.width=self.widthStatic;
   self.height=self.heightStatic;
   self.show("iframe");

   self.options.list["view"].removeEvent("click", self.view);
   self.editOption("view", "viewLarge", "Show large", self.view);
  }
  else
  {
   container.style.position="absolute";
   container.style.backgroundColor="#FFFFFF";
   container.style.width="100%";
   container.style.height="100%";
   container.style.zIndex=1000;

   container.style.top=0;
   container.style.left=0;

   if(window.innerHeight)
   {
    self.height=window.innerHeight-50;
    container.style.height=window.innerHeight+"px";
   }
   else
   {
    self.height=document.body.clientHeight-50;
    container.style.height=document.body.clientHeight+"px";
   }

   self.show("iframe");

   self.options.list["view"].removeEvent("click", self.view);
   self.editOption("view", "viewNormal", "Show normal", self.view);
  }
 }

 function error(text, clean)
 {
  if(typeof(clean)!="undefined")
   self.errorWindow.lastChild.innerHTML="";

  self.show("error");
  self.errorWindow.lastChild.innerHTML+=text+"<br/>";
 }


 function ieOnload()
 {
  if(self.wysiwyg.body==null)
   setTimeout('wysiwygs['+self.id+'].ieOnload();', 100);
  else
   self.sync("iframe");
 }


 function getRootFolder()
 {
  var stripURN=document.location.pathname;
  var pathDepth=rootpath.split("../").length-1;

  for(var c=0;c<pathDepth;c++)
   stripURN=stripURN.replace(/[^\/]*\/$/, "");

  return stripURN;
 }



//SELECTION

 function detectTag()
 {
  if(browser.match(/internet explorer/i))
  {
   var range=self.wysiwyg.selection.createRange();

   if(range.parentElement)
    var node=range.parentElement();
   else
    var node=range.item(0);
  }
  else
  {
   var node=self.iframe.contentWindow.getSelection().focusNode.parentNode;

   if(node.nodeName.toLowerCase()=="html"||node.nodeName.toLowerCase()=="body")
    node=self.iframe.contentWindow.getSelection().getRangeAt(0).cloneContents().childNodes[0];
  }

  if(!node)
   return false;

  switch(node.nodeName.toLowerCase())
  {
   case "font":
   {
    if(!document.getElementById("fontsize"))
     break;

    for(var c=0;c<document.getElementById("fontsize").options.length;c++)
    {
     if(document.getElementById("fontsize").options[c].value==node.style.fontSize)
     {
      document.getElementById("fontsize").selectedIndex=c;
      break;
     }
    }

    break;
   }
   case "a":
   {
    var tmp="";
    var link=node.getAttribute("href");

    if(tmp=link.match(/^mailto:(.*)$/))
    {
     document.getElementById("linkemail").value=tmp[1];
     document.getElementById("linkemailtitle").value=node.title;

     if(self.popup.style.display=="block")
      self.showPopup("email");
    }
    else if((tmp=link.match(/file\.php\?(m=([^&]+)&.*)?nr\=([0-9]+)/))||(tmp=link.match(/files\/(([^\/]+)\/([0-9]+))/)))
    {
     var module=tmp[2];
     var nr=tmp[3];

     if(!module)
      module="files"; //backwards compatibility

     document.getElementById("filenr").selectedIndex=0;
     for(var c=0;c<document.getElementById("filenr").options.length;c++)
     {
      if(document.getElementById("filenr").options[c].value==module+"."+nr)
      {
       document.getElementById("filenr").selectedIndex=c;
       break;
      }
     }

     document.getElementById("filetitle").value=node.title;

     if(node.getAttribute("onclick"))
      var target="popup";
     else if(node.getAttribute("rel"))
      var target=node.getAttribute("rel");
     else if(node.getAttribute("target"))
      var target=node.getAttribute("target");
     else
      var target="";

     document.getElementById("filetarget").selectedIndex=0;
     for(var c=0;c<document.getElementById("filetarget").options.length;c++)
     {
      if(document.getElementById("filetarget").options[c].value==target)
      {
       document.getElementById("filetarget").selectedIndex=c;
       break;
      }
     }

     if(self.popup.style.display=="block")
      self.showPopup("filesEdit");
    }
    else
    {
     document.getElementById("linknormal").value=node.href;
     document.getElementById("linknormaltitle").value=node.title;

     if(node.getAttribute("onclick"))
      var target="popup";
     else if(node.getAttribute("rel"))
      var target=node.getAttribute("rel");
     else if(node.getAttribute("target"))
      var target=node.getAttribute("target");
     else
      var target="";

     document.getElementById("linknormaltarget").selectedIndex=0;
     for(var c=0;c<document.getElementById("linknormaltarget").options.length;c++)
     {
      if(document.getElementById("linknormaltarget").options[c].value==target)
      {
       document.getElementById("linknormaltarget").selectedIndex=c;
       break;
      }
     }

     if(self.popup.style.display=="block")
      self.showPopup("links");
    }

    break;
   }
   case "img":
   {
    var tmp="";
    if((tmp=node.src.match(/image\.php\?(m=([^&]+)&.*)?nr\=([0-9]+)(&.*rotate=([^&]+))?/))||(tmp=node.src.match(/images\/(([^\/]+)\/([0-9]+))(\/.*rotate\/([^\/]+))?/)))
    {
     var module=tmp[2];
     var nr=tmp[3];
     var rotate=tmp[5];

     if(!module)
      module="images"; //backwards compatibility
     if(!rotate)
      rotate="";

     document.getElementById("imagenr").value=nr;
     document.getElementById("imagemodule").value=module;

     document.getElementById("imagerotate").selectedIndex=0;
     for(var c=0;c<document.getElementById("imagerotate").options.length;c++)
     {
      if(document.getElementById("imagerotate").options[c].value==rotate)
      {
       document.getElementById("imagerotate").selectedIndex=c;
       break;
      }
     }

     if(self.config["modRewrite"])
      document.getElementById("imagenr").src=rootpath+"images/"+module+"/"+nr+"/width/"+self.config["imagesThumbWidth"]+"/";
     else
      document.getElementById("imagenr").src=rootpath+"images/?m="+module+"&nr="+nr+"&width="+self.config["imagesThumbWidth"];
    }
    else
     document.getElementById("imagenr").src=node.src;

    document.getElementById("imagealt").value=node.alt;

    var size;
    if(node.width) //get size from width attribute (in case wysiwyg isn't cleaned yet)
     document.getElementById("imagewidth").value=node.width;
    else if(size=node.style.width.match(/([\d]+)[^\d].*/)) //get size from style
     document.getElementById("imagewidth").value=size[1];
    else if(size=node.src.match(/.*width[=\/]([\d]+)[^\d].*/)) //get sizeof from url
     document.getElementById("imagewidth").value=size[1];
    else
     document.getElementById("imagewidth").value="";

    if(node.height) //get size from height attribute (in case wysiwyg isn't cleaned yet)
     document.getElementById("imageheight").value=node.height;
    else if(size=node.style.height.match(/([\d]+)[^\d].*/)) //get size from style
     document.getElementById("imageheight").value=size[1];
    else if(size=node.src.match(/.*height[=\/]([\d]+)[^\d].*/)) //get sizeof from url
     document.getElementById("imageheight").value=size[1];
    else
     document.getElementById("imageheight").value="";


    if(self.popup.style.display=="block")
     self.showPopup("imagesEdit");

    break;
   }
   default:
   {
    if(document.getElementById("fontsize"))
     document.getElementById("fontsize").selectedIndex=0;

    break;
   }
  }

  return node.nodeName.toLowerCase();
 }


 function getSelection(textOnly)
 {
  return self.selection.getText(self.wysiwyg);
  return self.selection.getHTML(self.wysiwyg);
 }

//MANIPULATION

 function clean(type)
 {
  var value="";

  switch(type)
  {
   case "iframe":
   {
    value=self.wysiwyg.body.innerHTML;
    break;
   }
   case "textarea":
   {
    value=self.textarea.value;
    break;
   }
   default:
   {
    self.error("Can't clean type: "+type);
    return false;
   }
  }

  if(browser.match(/internet explorer/i))
  {
   //add ; at end of style attribute
   value=value.replace(/(style=\"[^\"]+[^\s;])\"/, "$1;\"");

   //add quotes around single word attributes
   value=value.replace(/ ([a-z0-9]+)=([a-z0-9]+)/, " $1=\"$2\"");
  }

  //convert attributes to style attribute
  var styleAttributes=Array(); //attribute(style option, suffix)
  styleAttributes["align"]=Array("text-align");
  styleAttributes["width"]=Array("width", "px");
  styleAttributes["height"]=Array("height", "px");

  for(var attribute in styleAttributes)
  {
   if(attribute=="in_array")
    continue;

   var tmp;
   var regxp=new RegExp("\<([^\>]+) "+attribute+"=\"([^\"]+)\"([^\>]*)\>", "i");
   while(tmp=value.match(regxp)) //find all attributes
   {
    if(!tmp[0].match(/ style=\"/)) //no style attribute yet
     value=value.replace(tmp[0], "<"+tmp[1]+" style=\""+styleAttributes[attribute][0]+": "+tmp[2]+(styleAttributes[attribute][1]?styleAttributes[attribute][1]:"")+";\""+tmp[3]+">"); //create style attribute with converted style
    else //style attribute already exists
    {
     var tmp2;
     var regxp2;
     if(tmp2=tmp[1].match(/ style=\"([^\"]*)\"/)) //style attribute in first section
     {
      //add/replace style option in style attribute
      if(tmp2[1].match(styleAttributes[attribute][0]+": \s*[^;]+;")) //style option already in style attribute
      {
       regxp2=new RegExp(" style=\"([^\"]*)("+styleAttributes[attribute][0]+":\s*[^;]+;)([^\"]*)\"");
       tmp[1]=tmp[1].replace(regxp2, " style=\"$1"+styleAttributes[attribute][0]+": "+tmp[2]+(styleAttributes[attribute][1]?styleAttributes[attribute][1]:"")+";$3\"")
      }
      else
      {
       regxp2=new RegExp(" style=\"([^\"]*)\"");
       tmp[1]=tmp[1].replace(regxp2, " style=\"$1 "+styleAttributes[attribute][0]+": "+tmp[2]+(styleAttributes[attribute][1]?styleAttributes[attribute][1]:"")+";\"")
      }
     }
     else if(tmp2=tmp[3].match(/ style=\"([^\"]*)\"/)) //style attribute in last section
     {
      //add/replace style option in style attribute
      if(tmp2[1].match(styleAttributes[attribute][0]+": \s*[^;]+;")) //style option already in style attribute
      {
       regxp2=new RegExp(" style=\"([^\"]*)("+styleAttributes[attribute][0]+":\s*[^;]+;)([^\"]*)\"");
       tmp[3]=tmp[3].replace(regxp2, " style=\"$1"+styleAttributes[attribute][0]+": "+tmp[2]+(styleAttributes[attribute][1]?styleAttributes[attribute][1]:"")+";$3\"")
      }
      else //new style option, add at end
      {
       regxp2=new RegExp(" style=\"([^\"]*)\"");
       tmp[3]=tmp[3].replace(regxp2, " style=\"$1 "+styleAttributes[attribute][0]+": "+tmp[2]+(styleAttributes[attribute][1]?styleAttributes[attribute][1]:"")+";\"")
      }
     }

     value=value.replace(tmp[0], "<"+tmp[1]+tmp[3]+">");
    }
   }
  }

  //convert tags to b,i,u and s
  value=value.replace(/\<STRONG\>([\s\S]*?)\<\/STRONG\>/gi, "<b>$1</b>");
  value=value.replace(/\<span[^\>]*?bold[^\>]*?\>([\s\S]*?)\<\/span\>/gi, "<b>$1</b>");

  value=value.replace(/\<EM\>([\s\S]*?)\<\/EM\>/gi, "<i>$1</i>");
  value=value.replace(/\<span[^\>]*?italic[^\>]*?\>([\s\S]*?)\<\/span\>/gi, "<i>$1</i>");

  value=value.replace(/\<U\>([\s\S]*?)\<\/U\>/g, "<u>$1</u>");
  value=value.replace(/\<span[^\>]*?underline[^\>]*?\>([\s\S]*?)\<\/span\>/gi, "<u>$1</u>");

  value=value.replace(/\<STRIKE\>([\s\S]*?)\<\/STRIKE\>/gi, "<s>$1</s>");
  value=value.replace(/\<span[^\>]*?line-through[^\>]*?\>([\s\S]*?)\<\/span\>/gi, "<s>$1</s>");

  //allowed tags and attributes
  var tags=Array();
  tags["p"]=Array("class", "style");
  tags["div"]=Array("class", "style", "id");
  tags["span"]=Array("class", "style");
  tags["font"]=Array("class", "style");
  tags["img"]=Array("class", "style", "src", "alt", "width", "height");
  tags["iframe"]=Array("class", "style", "src");
  tags["br"]=Array("class");
  tags["ul"]=Array();
  tags["ol"]=Array();
  tags["li"]=Array();
  tags["h1"]=Array();
  tags["h2"]=Array();
  tags["h3"]=Array();
  tags["h4"]=Array();
  tags["h5"]=Array();
  tags["h6"]=Array();
  tags["b"]=Array();
  tags["i"]=Array();
  tags["u"]=Array();
  tags["s"]=Array();
  tags["a"]=Array("href", "target", "onclick", "rel", "title", "name");

  //convert tags to [tags]
  for(var tag in tags)
  {
   if(tag!="in_array")
   {
    var regxp=new RegExp("\\\<("+tag+")\\\>", "gi"); //empty tags
    value=value.replace(regxp, "[$1]");
    var regxp=new RegExp("\\\<(\\\/"+tag+")\\\>", "gi"); //close tag
    value=value.replace(regxp, "[$1]");
    var regxp=new RegExp("\\\<("+tag+"\\\/)\\\>", "gi"); //short tag
    value=value.replace(regxp, "[$1]");
    var regxp=new RegExp("\\\<("+tag+" [^\\\>]*)\\\>", "gi"); //tag with attributes
    value=value.replace(regxp, "[$1]");
   }
  }

  value=value.replace(/\<[^\>]+\>/g, ""); //remove all remaining tags

  for(var tag in tags)
  {
   if(tag!="in_array")
   {
    var regxp=new RegExp("(\\\["+tag+"[^\\\]]*\\\])", "gi");

    var m1, m2;
    if(m1=value.match(regxp))
    {
     for(var c=0;c<m1.length;c++)
     {
      var newTag="["+tag;

      for(var x=0;x<tags[tag].length;x++)
      {
       var attribute=tags[tag][x];
       regxp=new RegExp(" "+attribute+"=\\\"([^\\\"]+)\\\"", "i");

       if(m2=m1[c].match(regxp))
       {
        var attrValue=m2[1];
        if(attribute=="style")
        {
         attrValue=attrValue.toLowerCase();
         attrValue=attrValue.replace(/margin:[^;]+;?/i, "");
         attrValue=attrValue.replace(/font-family:[^;]+;?/i, "");
         attrValue=attrValue.replace(/font:[^;]+;?/i, "");
         attrValue=attrValue.replace(/mso-[^:]+:[^;]+;?/i, "");
         attrValue=attrValue.replace(/line-height: normal;/i, "");
        }
        else if(attribute=="class")
        {
         attrValue=attrValue.replace(/MsoNormal/i, "");
        }

        attrValue=attrValue.replace(/^\s+$/, "");

        if(attrValue)
         newTag+=" "+attribute+"=\""+attrValue+"\"";
       }
      }
      newTag+="]";

      value=value.replace(m1[c], newTag);
     }
    }

    regxp=new RegExp("\\\[(\\\/?)("+tag+")([^\\\]]*)\\\]", "gi");
    value=value.replace(regxp, "<$1"+tag+"$3>");
   }
  }

  //remove useless tags
  value=value.replace(/\<font\>([^\<]+)\<\/font\>/gi, "$1");
  value=value.replace(/\<span\>([^\<]+)\<\/span\>/gi, "$1");

  //remove empty tags
  value=value.replace(/\<b\>\s*\<\/b\>/g, "");
  value=value.replace(/\<u\>\s*\<\/u\>/g, "");
  value=value.replace(/\<i\>\s*\<\/i\>/g, "");
  value=value.replace(/\<s\>\s*\<\/s\>/g, "");
  value=value.replace(/\<a[^\>]*\>\s*\<\/a\>/g, "");
  value=value.replace(/\<font[^\>]*\>\s*\<\/font\>/g, "");
  value=value.replace(/\<span[^\>]*\>\s*\<\/span\>/g, "");

  //replace caps incorrect <BR> tags with correct <br/> tags
  value=value.replace(/\<BR([^\>\/]*)\/?\>\n?/gi, "<br$1/>\n");

  //cleanup p tags
  value=value.replace(/\<p\>[\s\n]*\<\/p\>/g, "");
  value=value.replace(/\<p\>[\s\n]*\<br\/\>[\s\n]*\<\/p\>/g, "<br/>\n");
  value=value.replace(/\<br\/\>\n\<\/p\>/g, "<br/></p>\n");

  //remove empty image tags
  value=value.replace(/\<img\>/g, "");

  //add enters after close tags
  value=value.replace(/(\<\/(p|div|span|h1|h2|h3|h4|h5|h6)\>)/gi, "$1\n");

  //replace excess space and enters
  value=value.replace(/[\s\n]+$/gm, "");

  if(value=="<br/>")
   value="";

  //get image widht/height from style attribute and place it in images/ url
  var imgs, img, url;
  if(imgs=value.match(/<img[^\>]*style=\"[^\"]*(width|height)[^\>]*>/ig))
  {
   for(var c=0;c<imgs.length;c++)
   {
    if(img=imgs[c].match(/<img[^\>]*style=\"[^\"]*width\:\s?(\d+)[^\>]*>/i)) //update width
    {
     if(url=img[0].match(/src=\"([^\"]*)(width[=\/])(\d+)([^\"]*)\"/)) //get width from url
     {
      if(img[1]!=url[3]) //resized
      {
       var newImg=img[0].replace(/src=\"[^\"]+\"/, "src=\""+url[1]+url[2]+img[1]+url[4]+"\""); //change size in URL
       value=value.replace(img[0], newImg); //replace image tag
      }
     }
     else //no size in url, add at end
     {
      var newImg;
      if(img[0].match(/src=\"[^?]+\"/)&&self.config["modRewrite"]) //rewrite (no ? in URL)
       newImg=img[0].replace(/(src=\"[^\"]+)\"/, "$1width/"+img[1]+"/\"");
      else
       newImg=img[0].replace(/(src=\"[^\"]+)\"/, "$1&width="+img[1]+"\"");

      value=value.replace(img[0], newImg); //replace image tag
     }
    }

    if(img=imgs[c].match(/<img[^\>]*style=\"[^\"]*height\:\s?(\d+)[^\>]*>/i)) //update height
    {
     if(url=img[0].match(/src=\"([^\"]*)(height[=\/])(\d+)([^\"]*)\"/)) //get height from url
     {
      if(img[1]!=url[3]) //resized
      {
       var newImg=img[0].replace(/src=\"[^\"]+\"/, "src=\""+url[1]+url[2]+img[1]+url[4]+"\""); //change size in URL
       value=value.replace(img[0], newImg); //replace image tag
      }
     }
     else //no size in url, add at end
     {
      var newImg;
      if(img[0].match(/src=\"[^?]+\"/)&&self.config["modRewrite"]) //rewrite (no ? in URL)
       newImg=img[0].replace(/(src=\"[^\"]+)\"/, "$1height/"+img[1]+"/\"");
      else
       newImg=img[0].replace(/(src=\"[^\"]+)\"/, "$1&height="+img[1]+"\"");

      value=value.replace(img[0], newImg); //replace image tag
     }
    }
   }
  }

  //rewrite url to correct rootpath
  var tmp;
  if(tmp=document.location.toString().match(/^([^\:]+\:\/\/[^\/]+)(\/.*\/)[^\/]*$/, "/")) //get URI (https://domain/folder/folder/)
  {
   var URL=tmp[1]; //https://domain/
   value=value.replace(URL, ""); //remove URL, file+images already point to rootpath
  }

  switch(type)
  {
   case "iframe":
   {
    self.wysiwyg.body.innerHTML=value;
    break;
   }
   case "textarea":
   {
    self.textarea.value=value;
    break;
   }
  }

  return true;
 }

 function cmd(cmd, arg)
 {
  if(cmd=="removeFormat")
  {
   self.textarea.value=self.wysiwyg.body.innerHTML.replace(/\<[^\>]+\>/g, "");
   self.textarea.value=self.textarea.value.replace(/([^\n\r]+)(\n\r|\r\n|\n|\r)/g, "<p>$1</p>\r\n");
   self.sync("iframe");
   return true;
  }

  if(browser.match(/internet explorer/i)) //restore selection on focus (lost on blur)
  {
   if(cmd=="formatBlock")
   {
    var tag=self.wysiwyg.createElement(arg);

    return self.cmdTag(tag);
   }
   else if(cmd=="insertHTML")
   {
    var range=self.wysiwyg.selection.createRange();

    if(range.pasteHTML)
     range.pasteHTML(arg);

    return true;
   }
   else if(cmd=="undo"||cmd=="redo")
   {
    var e=Object();
    e.ctrlKey=true;

    if(cmd=="undo")
     e.keyCode=90;
    else
     e.keyCode=89;

    return self.iframeEvent(e);
   }
  }

  self.wysiwyg.execCommand(cmd, false, arg);

  if(cmd=="paste")
   self.clean("iframe");

  self.iframeEvent(null);
  return true;
 }

 function cmdTag(element)
 {
  if(element.nodeName.toLowerCase()!="img")
  {
   var text=self.selection.getHTML(self.wysiwyg, true); //get stored selection for tag content

   if(text) //remove sub nodes of same type
   {
    var regxp=new RegExp("<\/?"+element.nodeName.toLowerCase()+"[^>]*>", "gi");
    text=text.replace(regxp, "");
   }

   element.innerHTML=text;
  }

  if(browser.match(/internet explorer/i))
  {
   self.selection.restore(self.wysiwyg); //restore selection to ensure text is still properly selected

   var range=self.wysiwyg.selection.createRange();

   if(range.pasteHTML)
   {
    range.pasteHTML(""); //remove selected text including tags (to ensure next paste doesn't leave surrounding tags)
    range.pasteHTML(element.outerHTML); //paste new element at current cursor position

    range.moveStart("character", -(element.innerHTML.length)); //cursor at end of new insertion after paste, move start text length back
    range.select(); //set selection
   }
   else
   {
    if(range.parentElement)
     var node=range.parentElement();
    else
     var node=range.item(0);

    node.outerHTML=element.outerHTML;
   }
  }
  else
  {
   var selection=self.iframe.contentWindow.getSelection();
   var range=selection.getRangeAt(0);

   range.deleteContents(); //remove selection
   range.insertNode(element); //insert new node at current cursor

   range.selectNode(element); //select new element
   selection.removeAllRanges(); //update selection (only needed in Opera)
   selection.addRange(range);
  }

  self.iframeEvent(null);
  return true;
 }


 function fontSize()
 {
  var fontsize=document.getElementById("fontsize").options[document.getElementById("fontsize").selectedIndex].value;
  var tag=self.wysiwyg.createElement("font");

  if(fontsize)
   tag.style.fontSize=fontsize;

  self.cmdTag(tag);
 }


 function unsetLink()
 {
  self.cmd("unlink", null);
  self.hide("popup");
 }

 function formSetLink()
 {
  self.setLink(
   document.getElementById('linknormal').value,
   document.getElementById('linknormaltitle').value,
   document.getElementById('linknormaltarget').options[document.getElementById('linknormaltarget').selectedIndex].value
  );
 }
 function setLink(value, title, target)
 {
  var tag=self.wysiwyg.createElement("a");
  tag.href=value;

  if(title)
   tag.title=title;
  else
   tag.title=self.selection.getText(self.wysiwyg);

  if(target)
  {
   if(target=="popup") //javascript popup
    tag.setAttribute("onclick", "window.open(this.href, target, 'menubar=no,location=no,width=800,height=600,top=50,left=50'); return false");
   else if(target=="_blank") //use old target based link
    tag.setAttribute("target", target);
   else //use rel attribute
    tag.setAttribute("rel", target);
  }

  self.cmdTag(tag);
 }

 function formSetEmailLink()
 {
  self.setEmailLink(
   document.getElementById('linkemail').value,
   document.getElementById('linkemailtitle').value
  );
 }
 function setEmailLink(value, title)
 {
  var tag=self.wysiwyg.createElement("a");
  tag.href="mailto:"+value;

  if(title)
   tag.title=title;
  else
   tag.title=self.selection.getText(self.wysiwyg);

  self.cmdTag(tag);
 }

 function formSetFileLink()
 {
  if(!document.getElementById('filenr').selectedIndex)
   self.cmd("unlink", null);
  else
   self.setFileLink(
    document.getElementById('filenr').options[document.getElementById('filenr').selectedIndex].value.split('.')[0],
    document.getElementById('filenr').options[document.getElementById('filenr').selectedIndex].value.split('.')[1],
    document.getElementById('filetitle').value,
    document.getElementById('filetarget').options[document.getElementById('filetarget').selectedIndex].value
   );
 }
 function setFileLink(module, value, title, target)
 {
  var url=self.getRootFolder();

  if(self.config["modRewrite"])
   url+="files/"+module+"/"+value+"/";
  else
   url+="files/?m="+module+"&nr="+value;

  self.setLink(url, title, target);
 }

 function formSetImage()
 {
  if(document.getElementById('imagescalelock').checked&&document.getElementById('imagewidth').value)
   document.getElementById('imageheight').value='';

  self.setImage(
   document.getElementById('imagemodule').value,
   document.getElementById('imagenr').value,
   document.getElementById('imagealt').value,
   document.getElementById('imagewidth').value,
   document.getElementById('imageheight').value,
   document.getElementById('imagerotate').value
  );
 }
 function setImage(module, value, alt, width, height, rotate)
 {
  var tag=self.wysiwyg.createElement("img");

  tag.src=self.getRootFolder();

  if(self.config["modRewrite"])
   tag.src+="images/"+module+"/"+value+"/";
  else
   tag.src+="images/?m="+module+"&nr="+value;

  if(rotate)
  {
   if(self.config["modRewrite"])
    tag.src+="rotate/"+(rotate)+"/";
   else
    tag.src+="&rotate="+rotate;
  }

  tag.style.width="";
  tag.style.height="";

  tag.alt=alt;

  if(width)
  {
   if(self.config["modRewrite"])
    tag.src+="width/"+(width)+"/";
   else
    tag.src+="&width="+width;

   tag.style.width=width+"px";
  }

  if(height)
  {
   if(self.config["modRewrite"])
    tag.src+="height/"+(height)+"/";
   else
    tag.src+="&height"+height;

   tag.style.height=height+"px";
  }

  self.cmdTag(tag);
 }


 function showSpecialchars()
 {
  self.showPopup('specialchar');
 }

 function showLinks()
 {
  document.getElementById('linknormal').value="";
  document.getElementById('linknormaltitle').value="";
  document.getElementById('linknormaltarget').selectedIndex=0;

  self.showPopup('links');
 }

 function showEmail()
 {
  document.getElementById('linkemail').value="";
  document.getElementById('linkemailtitle').value="";

  self.showPopup('email');
 }

 function showFiles()
 {
  document.getElementById('filenr').selectedIndex=0;
  document.getElementById('filetitle').value="";
  document.getElementById('filetarget').selectedIndex=0;

  self.showPopup('files');
 }

 function showImages()
 {
  document.getElementById('imagemodule').value="";
  document.getElementById('imagenr').value=""
  document.getElementById('imagealt').value="";
  document.getElementById('imagewidth').value=self.config["imagesDefaultWidth"];
  document.getElementById('imageheight').value="";
  document.getElementById('imagerotate').selectedIndex=0;

  self.showPopup('images');
 }



//OPTIONS

 function addOption(option, img, alt, onclick)
 {
  if(option=="spacer")
  {
   tmp=document.createElement("div");
   tmp.style.margin="10px";
   tmp.style.display="inline";
   self.options.appendChild(tmp);
  }
  else if(option=="break")
  {
   tmp=document.createElement("div");
   tmp.style.margin="0px";
   self.options.appendChild(tmp);
  }
  else
  {
   self.options.list[option]=document.createElement("img");
   self.options.list[option].src=rootpath+"images/wysiwyg/"+img+".png";
   self.options.list[option].name=option;
   self.options.list[option].img=img;
   self.options.list[option].alt=alt;

   self.options.list[option].addEvent("click", onclick);

   self.options.list[option].style.margin="2px";
   self.options.list[option].style.cursor="pointer";
   self.options.appendChild(self.options.list[option]);
  }
 }

 function editOption(option, img, alt, onclick)
 {
  self.options.list[option].src=rootpath+"images/wysiwyg/"+img+".png";
  self.options.list[option].img=img;

  if(self.lang)
   self.options.list[option].alt=self.lang.t(alt);
  else
   self.options.list[option].alt=alt;

  self.options.list[option].addEvent("click", onclick);
 }

 function cmdOption(e)
 {
  if(option=(e.target||e.srcElement))//real e
  {
   var cmd=option.name;

   if(cmd=="formatBlock")
    var arg=option.img.toUpperCase();
   else
    var arg=null;
  }
  else
  {
   self.error("Can't determine command!");
   return false;
  }

  return self.cmd(cmd, arg);
 }

//EVENTS

 function iframeEvent(e)
 {
  if(browser.match(/internet explorer/i))
  {
   if(e&&e.ctrlKey)
   {
    if(e.keyCode==90) //undo
    {
     var tmp=self.wysiwyg.body.innerHTML.toString();
     for(var c=0;c<50;c++)
     {
      self.wysiwyg.execCommand("undo", false, null);
      if(tmp!=self.wysiwyg.body.innerHTML)
       break;
     }
     return false;
    }
    else if(e.keyCode==89) //redo
    {
     var tmp=self.wysiwyg.body.innerHTML;
     for(var c=0;c<50;c++)
     {
      self.wysiwyg.execCommand("redo", false, null);
      if(tmp!=self.wysiwyg.body.innerHTML)
       break;
     }
     return false;
    }
    else if(e.keyCode==86) //paste
     self.clean("iframe")
   }
  }


  if(e&&typeof(e.type)!="undefined"&&e.type=="dblclick")
  {
   var tmp=self.detectTag();
   if(tmp=="a"||tmp=="img")
    self.showPopup("links");
  }

  self.sync("textarea");
  self.clean("textarea");
  self.selection.store(self.wysiwyg);

  self.detectTag();

  return true;
 }

 function textareaEvent(e)
 {
  self.sync("iframe");
  self.clean("iframe");
  self.selection.store(self.textarea);

  return true;
 }


//DYNAMIC CONTENT

 function loadConfig()
 {
  if(typeof(HTTP)=="undefined")
  {
   self.error("Unable to load configuration: HTTP script not found, make sure you\'ve included http.js");
   return false;
  }

  var http=new HTTP()

  if(!http.data("configWYSIWYG"))
  {
   if(!http.error.match(/^sql: /i)&&!http.error.match(/^Error: XML API is disabled/i)) //not a sql error (table doesn't exist)
    self.error(http.error);
  }
  else if(v=http.next())
  {
   for(key in v)
   {
    if(typeof(v[key])=="string"&&v[key].match(/;/))
     self.config[key]=v[key].split(";");
    else if(v[key]=="false")
     self.config[key]=false;
    else if(v[key]=="true")
     self.config[key]=true;
    else
     self.config[key]=v[key];
   }

   return true;
  }

  return false;
 }


 function loadSpecialCharacters()
 {
  var charsperline=30;
  var symbols=Array("&nbsp;", "&iexcl;", "&cent;", "&pound;", "&curren;", "&yen;", "&brvbar;", "&sect;", "&uml;", "&copy;", "&ordf;", "&laquo;", "&not;", "&shy;", "&reg;", "&macr;", "&deg;", "&plusmn;", "&sup2;", "&sup3;", "&acute;", "&micro;", "&para;", "&middot;", "&cedil;", "&sup1;", "&ordm;", "&raquo;", "&frac14;", "&frac12;", "&frac34;", "&iquest;", "&times;", "&divide;");
  var characters=Array("&Agrave;", "&Aacute;", "&Acirc;", "&Atilde;", "&Auml;", "&Aring;", "&AElig;", "&Ccedil;", "&Egrave;", "&Eacute;", "&Ecirc;", "&Euml;", "&Igrave;", "&Iacute;", "&Icirc;", "&Iuml;", "&ETH;", "&Ntilde;", "&Ograve;", "&Oacute;", "&Ocirc;", "&Otilde;", "&Ouml;", "&Oslash;", "&Ugrave;", "&Uacute;", "&Ucirc;", "&Uuml;", "&Yacute;", "&THORN;", "&szlig;", "&agrave;", "&aacute;", "&acirc;", "&atilde;", "&auml;", "&aring;", "&aelig;", "&ccedil;", "&egrave;", "&eacute;", "&ecirc;", "&euml;", "&igrave;", "&iacute;", "&icirc;", "&iuml;", "&eth;", "&ntilde;", "&ograve;", "&oacute;", "&ocirc;", "&otilde;", "&ouml;", "&oslash;", "&ugrave;", "&uacute;", "&ucirc;", "&uuml;", "&yacute;", "&thorn;", "&yuml;");

  var table="<table class=\"specialchars\">";
  table+="<tr><td colspan=\""+charsperline+"\">"+self.lang.t("Symbols")+"</td>";

  for(c=0;c<symbols.length;c++)
  {
   if(c%charsperline==0)
    table+="</tr><tr>";

   table+="<td><a style=\"cursor: pointer;\" onclick=\"wysiwygs["+self.id+"].cmd('insertHTML', this.innerHTML);\" title=\""+symbols[c]+"\">"+symbols[c]+"</a></td>";
  }

  table+="</tr>";
  table+="<tr><td colspan=\""+charsperline+"\">&nbsp;</td></tr>";
  table+="<tr><td colspan=\""+charsperline+"\">"+self.lang.t("Characters")+"</td>";

  for(c=0;c<characters.length;c++)
  {
   if(c%charsperline==0)
    table+="</tr><tr>";

   table+="<td><a style=\"cursor: pointer;\" onclick=\"wysiwygs["+self.id+"].cmd('insertHTML', this.innerHTML);\" title=\""+characters[c]+"\">"+characters[c]+"</a></td>";
  }

  table+="</tr></table>";

  self.popup.specialchar.innerHTML=table;
 }


 function loadFilesList()
 {
  if(typeof(HTTP)=="undefined")
  {
   self.error("Unable to files list: HTTP script not found, make sure you\'ve included http.js");
   return false;
  }

  //ensure modules is an array
  var modules=self.config["filesModules"];
  if(typeof(modules)=="string")
   modules=Array(modules);

  if(!modules.length) //no modules
   return true;

  var http=new HTTP()
  self.popup.files.innerHTML="";

  var selectOptions=0;
  document.getElementById("filenr").options[selectOptions++]=new Option("", "");

  for(var c=0;c<modules.length;c++)
  {
   //get module definition
   if(!http.module(modules[c]))
   {
    self.error(http.error);
    return false;
   }

   var v=http.next();
   var title=v["title"];
   var module=v["name"];

   //determine title field
   var titleField=false;
   for(field in v["fields"])
   {
    if(v["fields"][field]["properties"]!=false&&v["fields"][field]["properties"].match(/title/))
    {
     titleField=field;
     break;
    }
   }

   //determine file/image field
   var fileField=false;
   var fileFieldType=false;
   for(field in v["fields"])
   {
    if(v["fields"][field]["type"]=="file"||v["fields"][field]["type"]=="localfile")
    {
     fileField=field;
     fileFieldType=v["fields"][field]["type"];
     break;
    }
   }

   if(!fileField)
   {
    self.error("Files module: "+title+" ("+module+") not usuable: no file fields");
    continue;
   }

   //clean up request
   http.clearRequest();
   http.clear();

   if(fileFieldType=="file")
    http.show("nr", titleField, fileField, fileField+"Size");
   else //localfile
    http.show("nr", titleField, fileField);

   //get data
   if(!http.data(module))
   {
    self.error(http.error);
    return false;
   }

   var table="<table class=\""+module+"\">";
   table+="<tr><th>"+title+"</th><th>"+self.lang.t("Filename")+"</th><th>"+self.lang.t("Size")+"</th></tr>";

   while(v=http.next())
   {
    table+="<tr>";
    table+="<td style=\"width: 45%;\"><a style=\"cursor: pointer;\" onclick=\"wysiwygs["+self.id+"].setFileLink('"+module+"', "+v["nr"]+");\" title=\""+v[titleField]+" - "+v[fileField]+"\">"+v[titleField]+"</a></td>";
    table+="<td style=\"width: 45%;\">"+v[fileField]+"</td>";

    if(fileFieldType=="file")
     table+="<td style=\"text-align: right;\">"+(v[fileField+"Size"]/1000).toFixed(1)+"KB</td>";
    else
     table+="<td style=\"text-align: right;\">&nbsp; </td>";

    table+="<tr>\n";

    document.getElementById("filenr").options[selectOptions++]=new Option(v[titleField], module+"."+v["nr"]);
   }

   table+="</tr></table><br/>";

   self.popup.files.innerHTML+=table;

   //clean up request
   http.clearRequest();
   http.clear();
  }

  return true;
 }


 function loadImagesList()
 {
  if(typeof(HTTP)=="undefined")
  {
   self.error("Unable to load images list: HTTP script not found, make sure you\'ve included http.js");
   return false;
  }


  //ensure modules is an array
  var modules=self.config["imagesModules"];
  if(typeof(modules)=="string")
   modules=Array(modules);

  if(!modules.length) //no modules
   return true;

  var http=new HTTP()
  self.popup.images.innerHTML="";

  for(var c=0;c<modules.length;c++)
  {
   //get module definition
   if(!http.module(modules[c]))
   {
    self.error(http.error);
    return false;
   }

   var v=http.next();
   var title=v["title"];
   var module=v["name"];

   //determine title field
   var titleField=false;
   for(field in v["fields"])
   {
    if(v["fields"][field]["properties"]!=false&&v["fields"][field]["properties"].match(/title/))
    {
     titleField=field;
     break;
    }
   }

   //determine file/image field
   var fileField=false;
   var fileFieldType=false;
   for(field in v["fields"])
   {
    if(v["fields"][field]["type"]=="image")
    {
     fileField=field;
     fileFieldType=v["fields"][field]["type"];
     break;
    }
   }

   if(!fileField)
   {
    for(field in v["fields"])
    {
     if(v["fields"][field]["type"]=="file"||v["fields"][field]["type"]=="localfile")
     {
      fileField=field;
      fileFieldType=v["fields"][field]["type"];
      break;
     }
    }
   }

   if(!fileField)
   {
    self.error("Image module: "+title+" ("+module+") not usuable: no file/image fields");
    continue;
   }

   //clean up request
   http.clearRequest();
   http.clear();

   if(fileFieldType=="image")
    http.show("nr", titleField, fileField, fileField+"Size", fileField+"ImageWidth", fileField+"ImageHeight");
   else if(fileFieldType=="file")
    http.show("nr", titleField, fileField, fileField+"Size");
   else //localfile
    http.show("nr", titleField, fileField);

   //get data
   if(!http.data(module))
   {
    self.error(http.error);
    return false;
   }

   var grid=title+"<br/>";

   while(v=http.next())
   {
    if(fileFieldType=="file"||fileFieldType=="localfile")
     if(!v[fileField].match(/\.(gif|png|jpg|jpeg)$/i))
      continue;

    grid+="<div style=\"float: left;\" onmouseover=\"this.childNodes[0].style.display='block';\" onmouseout=\"this.childNodes[0].style.display='none';\">";

    grid+="<div style=\"background-color: white; border: 1px solid grey; padding: 3px; display: none; position: absolute; margin: "+(self.config["imagesThumbWidth"]/4)+"px 0px 0px "+(self.config["imagesThumbWidth"]-10)+"px;\">";
    grid+=""+v[titleField]+"<br/>";
    grid+=self.lang.t("Filename")+": "+v[fileField]+"<br/>";

    if(fileFieldType=="image")
    {
     grid+=self.lang.t("Resolution")+": "+v[fileField+"ImageWidth"]+"x"+v[fileField+"ImageHeight"]+"<br/>";
     grid+=self.lang.t("Size")+": "+(v[fileField+"Size"]/1000).toFixed(1)+"KB<br/>";
    }
    else if(fileFieldType=="file")
     grid+=self.lang.t("Size")+": "+(v[fileField+"Size"]/1000).toFixed(1)+"KB<br/>";

    grid+="</div>";

    grid+="<a style=\"cursor: pointer;\" onclick=\"wysiwygs["+self.id+"].setImage('"+module+"', "+v["nr"]+", '', "+self.config["imagesDefaultWidth"]+");\" title=\""+v[titleField]+" - "+v[fileField]+"\"><img src=\""+rootpath+"images/?m="+module+"&nr="+v["nr"]+"&width="+self.config["imagesThumbWidth"]+"\" style=\"width: "+self.config["imagesThumbWidth"]+"px\" alt=\""+v[titleField]+" - "+v[fileField]+"\"></a>";
    grid+="</div>";
   }

   self.popup.images.innerHTML+=grid+"<br style=\"clear: both;\"/><br/>";

   //clean up request
   http.clearRequest();
   http.clear();
  }

  return true;
 }


 function loadTranslations()
 {
  if(typeof(Language)=="undefined")
   return false;

  self.lang=new Language();

  if(!self.lang.read("wysiwyg"))
  {
   if(self.lang.error)
    self.error(self.lang.error);

   return false;
  }

  var tmp=self.options.getElementsByTagName("img");
  for(var c=0;c<tmp.length;c++)
   tmp[c].alt=self.lang.t(tmp[c].alt);

  var tmp=self.popup.getElementsByClassName("title");
  for(var c=0;c<tmp.length;c++)
   tmp[c].innerHTML=self.lang.t(tmp[c].innerHTML);

  var tmp=self.popup.getElementsByClassName("submit");
  for(var c=0;c<tmp.length;c++)
   tmp[c].value=self.lang.t(tmp[c].value);

  var tmp=self.popup.getElementsByTagName("label");
  for(var c=0;c<tmp.length;c++)
   tmp[c].childNodes[1].nodeValue=self.lang.t(tmp[c].childNodes[1].nodeValue);

  self.popup.specialchar.childNodes[0].nodeValue=self.lang.t(self.popup.specialchar.childNodes[0].nodeValue);
  self.popup.files.childNodes[0].nodeValue=self.lang.t(self.popup.files.childNodes[0].nodeValue);
  self.popup.images.childNodes[0].nodeValue=self.lang.t(self.popup.images.childNodes[0].nodeValue);

  return true;
 }

}
